Bruce the Presentation Tool is for Python programmers who are tired of
fighting with presentation tools. In its basic form it allows text, code or
image pages and even interactive Python and shell sessions. It uses PyGame 
and is easily extensible to add new page types.


Installation
============

To install Bruce, run::

    # python setup.py install

if you're running Python < 2.5 then you will receive a message like::

    UserWarning: Unknown distribution option: 'requires'

which you may ignore.


Usage
=====

The best way to use bruce is to use the socrates.py driver script. See 
/usr/local/share/doc/socrates.txt for more. Alternately, you can write your presentation 
as a Python script which imports "bruce.main" and calls 
"bruce.main.main(pages)" where "pages" is a sequence of
bruce.page.Page objects. Then::

    % python <presentation file>

will run the presentation.


Controls
========

left, right arrows
  Move back and forward pages (and expose/hide "-" marked text lines)
up, down arrows
  Move back and forward 5 pages (ignores expose/hide text lines)
control-I
  Enter / exit auto-type mode in the interactive interpreter
control-F
  Switch between fullscreen and windowed mode (X11 only)
escape
  Exit presentation
home, end
  Go to the first or last page


Samples
=======

See the examples in the Subversion repository at:

  http://bruce.python-hosting.com/browser/

in particular the simple:

  http://bruce.python-hosting.com/file/trunk/examples/example.py

Note that both examples specify explicit fonts from the Vera family. I
recommend you do the same as pygame's SystemFont can produce unpredictable
and sometimes ugly results.

The latest and greatest code is always available via SVN, at the repository
http://svn.bruce.python-hosting.com/trunk. Thanks to the python-hosting folks
for the free service!


Docs
====

See /usr/local/share/doc/socrates.txt 

License
=======

Copyright (c) 2005,2006,2007 Richard Jones (richard at mechanicalcat)
and contributors.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

                     BRUCE v2.8

Please read *ALL* of this file before doing anything!

1) Legal stuff

    Bruce v2.8 Non-Radial Pulsation Code - Richard Townsend
    Copyright (C) 1997,1998,1999,2000 Richard Townsend

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.

2) Description

    Bruce is a FORTRAN program which models non-radial pulsation in
    rotating stars. For a complete description of the program, see
    "Spectroscopic modelling of non-radial pulsation in rotating early-type
    stars" - Townsend R H D, 1997, MNRAS 284, 139. An even fuller
    description can be found in "Non-radial pulsation in early-type
    stars" - Townsend R H D, 1997, PhD Thesis, University of London.
    This thesis may be downloaded on the web from:

      http://www.star.ucl.ac.uk/~rhdt/download/thesis.ps.gz

3) Manifest
 
    Files in the top-level directory:

      ./README   - this file
      ./COPYING  - legal copying info (the GPL)
      ./CHANGES  - release & update info
      ./Makefile - standard makefile for building the executables

    The main distribution comes in three subdirectories:
      
      ./bruce/*  - source files for bruce
      ./lsdlib/* - source files for the LSD library, used by bruce
      ./kylie/*  - source files for kylie

    Kylie does not really form part of the distribution, but is
    included to illustrate typical methods of using "dump files" produced
    by bruce. It is anticipated that authors will integrate kylie with
    their own spectral synthesis routines (parts which need modification
    for such an integration are marked with MODIFY: comments in the code).
    Once you have your "integrated" version of kylie, edit ./kylie/Makefile
    as is needed, and add "kylie" to the SUBDIRS definition in ./Makefile.
    Note that kylie is covered by the GPL.

4) Installation

    To compile bruce, edit ./Makefile so that compilation flags 
    suitable for your computer and FORTRAN compiler are set.
    Then type "make" to compile. All of the source will (hopefully) 
    compile to produce the executable "bruce" in the ./bruce/ subdirectory.
    Of course, this assumes you have the make utility!

5) Running bruce

    To run bruce, place the executable in your exec path, and just type

      bruce < command_file

    where command_file is a command file compliant with the syntax described
    in the author's PhD thesis & CHANGES notes (see above). Happy modelling!

6) Documentation

    The source code for bruce is extensively commented. Documentation
    on the physics behind bruce, and the command file syntax, can be
    found in the author's PhD thesis (see above). IMPORTANT - Please also
    read the CHANGES file, since this will contain updates to the documentation
    which reflect modifications to bruce.

7) Support

    This "product" is now supported - sort of! Any problems, drop the
    author an email at rhdt@star.ucl.ac.uk.

8) Acknowledgement

    Any published scientific work which uses bruce, or is based upon
    bruce, should acknowledge both bruce and its author, Richard Townsend,
    at some point in the publication (go on, put me on the author list!).

9) Updates

    You should look (as frequently as possible) at the bruce website:

      http://www.star.ucl.ac.uk/~rhdt/download/

    This will contain updates/bugfixes to the program, as and when they
    become available.

10) User-list

    If you are an active user of bruce, drop me an email at rhdt@star.ucl.ac.uk,
    so that I can keep an up-to-date list of users. This will enable me to
    inform people when significant updates or bugfixes are implemented.

Bruce the Presentation Tool is for Python programmers who are tired of
fighting with presentation tools. In its basic form it allows text, code or
image pages and even interactive Python sessions. It uses PyGame and is
easily extensible to add new page types.


Usage
=====

Write your presentation as a Python module or package. Then:

  bruce-play <module name> [-win]

or in Windows:

  python bruce-play <module name> [-win]

will import the presentation and attempt to access a function called
"pages" which it uses to get a sequence of pages to display. The "-win"
swtich runs the presentation in a window instead of full-screen.


Controls
========

left, right arrows
  Move back and forward pages (and expose/hide "-" marked text lines)
up, down arrows
  Move back and forward 5 pages (ignores expose/hide text lines)
control-I
  Enter / exit auto-type mode in the interactive interpreter
escape
  Exit presentation
home, end
  Go to the first or last page


Sample
======

This is a sample which includes use of all of the default page types::

    from bruce.text import TextPage
    from bruce.interp import InterpreterPage
    from bruce.scratch_interp import ScratchPadInterpreterPage
    from bruce.codefile import CodeFilePage
    from bruce.image import ImagePage

    opening_pages = '''
    =Games In Python

    MPUG, Sept 2005
    ---
    =How do you make a game?

    Control the screen & speakers
    -User interaction
    -World simulation
    '''

    def pages():
        l = []
        # some intro
        for page in opening_pages.split('---'):
            l.append(TextPage(page))

        l.append(InterpreterPage('Zen of Python', 'import this'))

    l.append(ScratchPadInterpreterPage('Draw to the Screen', '''
car = pygame.image.load('car.png')
car
scratch.blit(car, (100, 100))
rotated = pygame.transform.rotate(car, 45)
scratch.blit(rotated, (150, 150))
'''))

        l.append(CodeFilePage("Sample Game", 'car_game.py'))

        # examples
        l.extend([
            ImagePage("POWER CORE from PyWeek 1", 'powercore.png'),
            ImagePage("POWER CORE dev screenshot", 'lotsa_ufos.png'),
            ImagePage("Dynamite from PyWeek 1", 'dynamite.png'),
            ImagePage("Pylonoid from PyWeek 1", 'pylonoid.jpg'),
        ])
        l.append(TextPage('''=Questions?

    www.pygame.org
    pyopengl.sf.net
    home.gna.org/oomadness
    www.imitationpickles.org/pgu
    '''))
        return l

License
=======

Copyright (c) 2005 Richard Jones (richard at mechanicalcat)

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

      subroutine bmakeg(ok)

C*******************************************************
C
C This subroutine constructs a partial stellar grid for
C use by BRUCE. The grid contains radius, area, temp and
C (vectorial) gravity for a number of points on the surface
C of a rotationally-distorted star with rotational angular
C omega. The grid is only calculated for colatitidue theta
C going from 0 to pi/2; this covers the 'northern' hemisphere,
C the southern hemisphere is just a mirror image of this.
C No phi dependance is included since all of the parameters
C in the grid are independant of phi.
C
C All variables are passed around using common blocks. A
C status variable is returned in ok - .true. indicates
C successful grid construction, .false. indicates an error
C 
C Started:18/9/95
C Modified:11/10/95
C
C  25/06/00 - Modified to calculate the disk area and the
C             the...
C
C (c) Richard Townsend 1995
C
C********************************************************

C Turn of implicit typing

      implicit none

C Define the hard-wired parameters

      include "bruce.compar_define.inc"

C Load in the stellar equilibrium grid include block

      include "bruce.eqstgr_common.inc"

C Load in the Stellar parameters include block

      include "bruce.stepar_common.inc"

C Declare the passed variables

      logical ok			! The returned status variable

C Declare the other parameters...

      double precision theta		! The colatitude theta
      double precision phi		! Guess
      double precision Radius		! The calculated radius at the current theta (using NR routine)
      double precision FRoot		! The function whose root is found to find the radius (bsically Ueff)
      double precision DFRoot		! The first derivative wrt Radius of DFRoot
      double precision GEffR		! The radial component of the effective gravity
      double precision GEffT		! The theta component of the effective gravity
      double precision ObsR		! The radial component of the observer vector for a given grid point
      double precision ObsT		! The theta component of the observer vector for a given grid point
      double precision ObsRC		! The radial component of the observer vector for a given conjugate grid point
      double precision ObsTC		! The theta component of the observer vector for a given conjugate grid point
      double precision cosMu		! The projected surface normal for a given grid point
      double precision cosMuC		! The projected surface normal for a given conjugate grid point
      integer gcount			! Counter to loop over the grid points (ie loop in theta)
      integer pcount			! Counter to loop over the phi points at some given theta (used for GrdVis/GrdTot)
      integer NGPhi			! The number of duplicate grid points needed in the phi direction at some theta

C Include the basic constants and angles

      include "constants.inc"
      include "angles.inc"

C Set up ok

      ok=.false.

C Set up DelThe

      DelThe=D90/dble(NGrid)

C Set up the initial value of Radius

      Radius=Rpole

C Also, work out TEq and GEq from TPole, Gpole, REq etc. Remember that GPole
C is the scalar (positive) polar gravity, so we must diddle the sign of GEq
C to be positive (this is what the initial - sign is for)

      GEq=-(Omega**2*REq-BigG*MStar/REq**2)

      TEq=TPole*(GEq/GPole)**Beta

C Initialise various calculated quantitites...

      LStar=0.D0
      AStar=0.D0
      VStar=0.D0

      ADisk=0.D0
      FDisk=0.D0

C Initialise GrdVis & GrdTot, the number of visible grid points and the total
C number of grid points respectively, to be zero

      GrdVis=0
      GrdTot=0

C Set up cDIncl and sDIncl for both bmakeg and bruce to use

      cDIncl=cos(DIncl)
      sDIncl=sin(DIncl)

C Write out a bit of info...

      write(chandl,
     : '('' Computing Stellar Grid...'')')

C Loop over the grid points, starting at the pole and working to the equator

      do gcount=1,NGrid,1

C Set up theta, making sure that the gcount=NGrid point is NOT on the pole (coz
C this leads to complications in BRUCE)

        theta=(gcount-0.5D0)/dble(NGrid)*D90

C Using a Newton-Raphson caculation, work out the radius of the star at this point. First
C get FRoot and DFRoot.

 1000   continue

        FRoot=0.5D0*(Omega*sin(theta))**2*Radius**2 
     :        -BigG*MStar/Rpole + BigG*MStar/Radius

        DFRoot=(Omega*sin(theta))**2*Radius - BigG*MStar/Radius**2

C Then check if the new radius differs from the old radius by less than the tolerance.
C If so, jump out of the loop

        if(abs((Radius-FRoot/DFRoot)/Radius-1.D0)
     :     .lt.RToler) goto 2000

C Otherwise update the radius and loop back

        Radius=Radius-FRoot/DFRoot
        goto 1000

C Jump in point for OK radius - do the last correction to radius		

 2000   continue

        Radius=Radius-FRoot/DFRoot

C Do a bounds check on the radius

        if(Radius.gt.Veq/Omega.or.Radius.lt.Rpole) then
          write(chandl,
     :    '(''*** There was a problem finding the stellar radius - '',
     :    ''Please request a recompile'')')
          goto 9000
        endif

C Bung it into the grid...

        RGrid(gcount)=Radius

C Work out the the radial and theta-components of the gravity vector, and get GGrid and NRGrid/NTGrid from
C them. Remember again that GEffR/GEffT are vector gravities, and can be negative, but GGrid must be
C positive since it is the scalar gravity.

        GEffR=Omega**2*Radius*sin(theta)-BigG*MStar/Radius**2
        GEffT=Omega**2*Radius*sin(theta)*cos(theta)

        GGrid(gcount)=sqrt(GEffR**2+GEffT**2)
        
        NRGrid(gcount)=-GEffR/GGrid(gcount)
        NTGrid(gcount)=-GEffT/GGrid(gcount)

C Set up the effective temperature using the gravity-darkening law  (von Zeipel)

        TGrid(gcount)=TPole*(GGrid(gcount)/GPole)**Beta

C Now we have to work out the area of the element associated with the grid point. First
C we work out the number of duplicate phi grid points we want to have at this colatitude
C so that each grid point has approx the same area. Make sure NGPhi is always greater than
C 1.

        NGPhi=int(NEqtr*sin(theta))+1       

C Now work out what range in phi each grid point will cover

        DelPhi=D360/NGPhi

C OK, now we can work out the area, which is given by the modulus of dA:
C
C                                     (       1        )
C    dA = R**2 sin(theta) dtheta dphi ( -1/R dR/dtheta )
C                                     (                )
C First work out dR/dtheta

        DRGrid(gcount)=(Omega**2*Radius**3*sin(theta)*cos(theta))/
     :      (BigG*Mstar/RPole-1.5D0*Omega**2*Radius**2*(sin(theta))**2)

C Now get the area...

        AGrid(gcount)=Radius**2*sin(theta)*DelThe*DelPhi*
     :                sqrt(1+(DRGrid(gcount)/Radius)**2)

C Now we do a loop over the number of phi grid points at this theta value, working out
C from the surface normal of each grid point whether this grid point is visible - we
C then update GrdVis (and GrdTot) accordingly, for both the northern and southern hemisphere
C points. First things first, though, we must work out the radial and theta components of
C this grid point and of the conjugate (southern-hemisphere) grid point.
C
C Also, update the various integrated quantities for the star...

        do pcount=1,NGPhi,1

          phi=(pcount-0.5D0)/dble(NGPhi)*D360

          ObsR= cDincl*cos(theta)+sDIncl*sin(theta)*cos(phi)
          ObsT=-cDIncl*sin(theta)+sDIncl*cos(theta)*cos(phi)

          ObsRC=-cDincl*cos(theta)+sDIncl*sin(theta)*cos(phi)
          ObsTC=-cDIncl*sin(theta)-sDIncl*cos(theta)*cos(phi)

          cosMu=ObsR*NRGrid(gcount)+ObsT*NTGrid(gcount)
          cosMuC=ObsRC*NRGrid(gcount)-ObsTC*NTGrid(gcount)

          LStar = LStar+2*AGrid(gcount)*TGrid(gcount)**4*BSigma
          AStar = AStar+2*AGrid(gcount)
          VStar = VStar+2*RGrid(gcount)**3*sin(theta)*DelThe*DelPhi/3.D0

          if(cosMu.ge.0.D0) then
             GrdVis=GrdVis+1
             ADisk = ADisk+cosMu*AGrid(gcount)
             FDisk = FDisk+cosMu*AGrid(gcount)*(1.-LIMBOL*(1.-cosMu))*
     :               TGrid(gcount)**4*BSigma/((1.-LIMBOL)/2.+LIMBOL/3.)
          endif

          if(cosMuC.ge.0.D0) then
             GrdVis=GrdVis+1
             ADisk = ADisk+cosMuC*AGrid(gcount)
             FDisk = FDisk+cosMuC*AGrid(gcount)*(1.-LIMBOL*(1.-cosMuC))*
     :               TGrid(gcount)**4*BSigma/((1.-LIMBOL)/2.+LIMBOL/3.)
          endif
 
          GrdTot=GrdTot+2

        enddo

C OK, that seems to be all, so loop back around...

      enddo

C Set up ok to be .true.

      ok=.true.

C This is the jump -in point for returning

 9000 continue

      return

      end

      function RAPmatx(beta,l,m,m2)

C*****************************************************
C
C This little function calculates an element
C of the irreducible matrix representation of
C the infinite rotation group. Basically, a
C spherical harmonic Yml which has been functionally
C rotated so that it's new polar axis lies in the xz
C plane at an angle of beta to the coordinate z-axis
C may be represented by a sum over original spherical
C harmonics:
C
C     Ylm(rotated) = Sum(m'=-l,m'=l) (dlmm' Ym'l)
C
C where dlmm' is returned by RAPmatx. m' is represented
C by m2; the other parameters are obvious (I hope!)
C
C See p110 of 'Group Theory & QM', M. Tinkham, 1st Ed 
C McGraw-Hill
C
C Started: 1/12/95
C
C (c) Richard Townsend 1995
C
C
C******************************************************

C Turn off implicit typing

      implicit none

C Declare the passed parameters

      double precision RAPmatx		! The returned matrix element
      double precision beta		! The rotation angle
      integer l				! The l-value of the harmonics
      integer m				! The m-value of the rotated harmonic
      integer m2			! The m-value of the 'basis' harmonic

C Declare the in-program parameters

      double precision gterm		! General term in working out the summation
      double precision rapfact		! The factorial function
      double precision tfact		! Temporary variable for storing rapfact
      double precision sbeta2		! sin(beta/2)
      double precision cbeta2		! cos(beta/2)
      integer k				! A summation counter to loop over terms

C Initialise the matrix element to zero

      RAPmatx=0.D0

C Set up sbeta2 and cbeta2

      sbeta2=sin(beta/2.D0)
      cbeta2=cos(beta/2.D0)

C Loop over k to add in each part of the matrix element

      do k=0,(2*l+1),1

C Initialise the general term

        gterm=(-1.D0)**k*dsqrt(
     :    rapfact(l+m)*rapfact(l-m)*
     :    rapfact(l+m2)*rapfact(l-m2))/
     :    rapfact(k)

C Add in the bits dependent on beta, checking for sin(beta/2)=0
C and cos(beta/2)=0.

        if(sbeta2.eq.0.D0) then
          if((2*k+m2-m).ne.0) gterm=0.D0
        else
          gterm=gterm*
     :    (-sbeta2)**(2*k+m2-m)
        endif

        if(cbeta2.eq.0.D0) then
          if((2*l-2*k-m2+m).ne.0) gterm=0.D0
        else
          gterm=gterm*
     :    (cbeta2)**(2*l-2*k-m2+m)
        endif

C Multiply by the other bits
                                                                             
        tfact=rapfact(l+m-k)
        if(tfact.eq.0.D0) then
          gterm=0.D0
        else
          gterm=gterm/tfact
        endif

        tfact=rapfact(l-k-m2)
        if(tfact.eq.0.D0) then
          gterm=0.D0
        else
          gterm=gterm/tfact
        endif

        tfact=rapfact(k+m2-m)
        if(tfact.eq.0.D0) then
          gterm=0.D0
        else
          gterm=gterm/tfact
        endif

C Add this to the matrix element and loop back around

        RAPmatx=RAPmatx+gterm

      enddo

C Return

      return

      end                         

      subroutine lsdvhor(vhor,m,eigval,n,np,
     :                  bvec,parity)

C***************************************************
C
C This function sets up a vector vhor which is used
C as a set of expansion coefficients in the calculation
C of the horizontal velocity
C function of Lee & Saio's Lambda basis (ApJ 1990)
C The horizontal (neglecting toroidal) velocity field
C of an NRP eigenstate is then the horizontal gradient
C of this function. The routine uses the eigenvector for
C the mode in question bvec, and also the eigenvale eigval.
C See lsdfhor for details....
C
C Stated:3/7/95
C Last Modified:4/12/95
C
C (c) Richard Townsend 1995
C
C*****************************************************

      implicit none		! Turn off implicit typing

C Declare the passed variables

      double precision eigval	! The eigenvalue corresponding to bvec
      integer m			! The m-value to use
      integer n			! The number of terms to sum over
      integer np		! The total size of bvec
      double precision bvec(np)	! The column vector containing the approp. eigenvector
      double precision vhor(np) ! The column vector containing the expansion coefficients
      logical parity		! The parity to be used - .true.=even

C Declare the in-program variables

      integer j			! The coefficient index
      integer am		! The absoulte value of m
      double precision parfac	! The partial factorial (l+|m|)...(l-|m|+1)

C Set up am=|m|
                             
      am=iabs(m)      

C And now loop over j to get the coefficients...

      do j=1,n

C We set the jth coefficient, depending on whether the parity
C is even (.true.) or odd (.false.)

        if(parity) then
          vhor(j)=eigval*bvec(j)*
     :     dsqrt((am+2*(j-1)+0.5D0)/
     :     parfac(am+2*(j-1),am))/
     :     ( (am+2*(j-1))*(am+1+2*(j-1)) )
        else
          vhor(j)=eigval*bvec(j)*
     :     dsqrt((am+2*(j-1)+1.5D0)/
     :     parfac(am+1+2*(j-1),am))/
     :     ( (am+1+2*(j-1))*(am+2+2*(j-1)) )
        endif

C Its as simple as that - now loop back around....

      enddo

C As a little safety check, we zero all the remaining coeffs...

      do j=n+1,np
        vhor(j)=0.D0
      enddo

C Thats all folks - return...

      return

      end

      subroutine breprt

C**************************************************
C
C This subroutine prints out diagnostic information
C on all of the parameters which bruce uses to perform
C its pulsation calculations.
C
C Started :19/9/95
C Modified:11/10/95
C          23/12/98 - Added reporting on new INCLUDE_ENDPOINTS switch
C          23/12/98 - Added reporting on new WRITE_TIMINGS_FILE switch
C          14/6/99  - Changed reporting of Equal Volume radius to reporting
C                     of effective temperature
C          13/6/99  - Modified the output format radically, primarily
C                     changing to the use of FORMAT statements (since this
C                     is far more portable)
C
C          22/6/00  - Various modifications to account for modifications
C                     elsewhere in BRUCE
C
C          25/6/00  - Added in reporting of various integrated stellar 
C                     quantities
C
C (c) Richard Townsend 1995,1999
C
C**************************************************

C Turn off implicit typing

      implicit none

C Define the hard-wired parameters

      include "bruce.compar_define.inc"

C Load in the Stellar parameters common block

      include "bruce.stepar_common.inc"

C Load in the Mode definition common block

      include "bruce.moddef_common.inc"

C Load in the file names common block

      include "bruce.filnam_common.inc"

C Load in the Field definition common block

      include "bruce.flddef_common.inc"

C Load in the Field switches common block

      include "bruce.fldswi_common.inc"

C Load in the equilibrium stellar grid common block

      include "bruce.eqstgr_common.inc"

C Declare the in-program variables

      integer modcnt			! Counts over the modes

C Bung in the constants and angles include files

      include "constants.inc"
      include "angles.inc"

C OK, we now have all of the parameters read in. We now proceed to print them
C out in a nice big display...

C Print out the stellar parameters

      write(chandl,100) 'Stellar Parameters'
 100  format(/'%%%'/'% ',A/'%%%'/)

      write(chandl,101) 'R_(pole/eq)',RPole/RSun,REq/RSun,'R_sun'
      write(chandl,101) 'g_(pole/eq)',log10(GPole)+2.D0,
     :log10(GEq)+2.D0,'cgs dex'
      write(chandl,101) 'T_(pole/eq)',TPole/1.D3,TEq/1.D3,'kK'
 101  format(A18,1X,':',1X,F7.2,2X,'/',1X,F7.2,1X,A)

      write(chandl,102) 'Mass',MStar/MSun,'M_sun'
      write(chandl,102) 'P_rotation',D360/(Omega*3600.D0),'hours'
      write(chandl,102) 'i',DIncl*360/D360,'degrees'
      write(chandl,102) 'V_eq',VEq/1.D3,'km/s'
      write(chandl,102) 'V_eq sin i',Veq*sin(DIncl)/1.D3,'km/s'
      write(chandl,102) 'V_eq/V_crit',VEq/VCrit,' '
 102  format(A18,1X,':',1X,F11.3,1X,A)
      write(chandl,102) 'R_eq/R_crit',REq/(1.5*RPole),' '
      write(chandl,102) 'Luminosity',log10(LStar/LSun),'L_sun dex'

      write(chandl,102) 'R (total area)',
     :sqrt(AStar/(4.*PI))/RSun,'R_sun'
      write(chandl,102) 'R (total volume)',
     :(3.*VStar/(4.*PI))**(1./3.)/RSun,'R_sun'
      write(chandl,102) 'R (disk area)',
     :sqrt(ADisk/PI)/RSun,'R_sun'
      
      write(chandl,102) 'Teff (total flux)',
     :(LStar/(AStar*BSigma))**(1./4.)*1.e-3,'kK'
      write(chandl,102) 'Teff (disk flux)',
     :(FDisk/(2*ADisk*BSigma))**(1./4.)*1.e-3,'kK'

C Print out the general modelling parameters      
      
      write(chandl,100) 'Modelling Parameters'

      write(chandl,103) 'No. of Fields',NField
      write(chandl,103) 'Visible Points',GrdVis
      write(chandl,103) 'Total Points',GrdTot
 103  format(A18,1X,':',1X,I7)
      
      write(chandl,104) 'Dump Filestub',DmStub
      write(chandl,104) 'Input times',TmFile
 104  format(A18,1X,':',1X,A)

      write(chandl,102) 'Start Time',Times(1)/3600.D0,'hours'
      write(chandl,102) 'Finish Time',Times(NField)/3600.D0,'hours'

      write(chandl,105) 'Write Aux',WrtAux
      write(chandl,105) 'Write Times',WrtTim
      write(chandl,105) 'ST Modes',LSDEff
      write(chandl,103) 'ST Dimension',MatDim
      write(chandl,105) 'Ro-Ap Modes',roAEff
      write(chandl,102) 'Ro-Ap Angle',RAxOff/D360*360.D0,'degrees'
      write(chandl,105) 'Normal fields',GrvFld
      write(chandl,105) 'Normal FX',NrmEff
      write(chandl,105) 'Area FX',SrfEff
      write(chandl,105) 'Temp. FX',TmpEff
      write(chandl,105) 'Horiz. FX',HorEff
 105  format(A18,1X,':',1X,L1)


C Write out the mode definitions

      do modcnt=1,NModes,1
         write(chandl,106) modcnt
        write(chandl,103) 'l',Lmode(modcnt)
        write(chandl,103) 'm',Mmode(modcnt)
        write(chandl,103) 'j',Jmode(modcnt)
        if(parity(modcnt)) then
           write(chandl,104) 'Parity','Even'
        else
           write(chandl,104) 'Parity','Odd'
        endif
        write(chandl,102) 'Amplitude',VAmode(modcnt)/1.D3,'km/s'
        write(chandl,102) 'K',Kmode(modcnt),' '
        write(chandl,102) 'P_corot',
     :D360/(CFmode(modcnt)*3600.D0),'hours'
        write(chandl,102) 'P_obs',
     :D360/((CFmode(modcnt)-Mmode(modcnt)*Omega)*3600.D0),'hours'
        write(chandl,102) 'Temp. Ampl.',TAmode(modcnt),' '
        write(chandl,102) 'Temp. Phase',TPmode(modcnt)*360.D0/D360,
     :'degrees'
        write(chandl,102) 'Horiz. Ampl.',HAmode(modcnt),' '
        write(chandl,102) 'Horiz. Phase',HPmode(modcnt)*360.D0/D360,
     :'degrees'
        write(chandl,102) 'Initial Phase',IPmode(modcnt)*360.D0/D360,
     :'degrees'
        write(chandl,102) 'nu',numode(modcnt),' '
      enddo

 106  format(/,'%%%',/,'% Mode Definition ',I3,/,'%%%',/)

C Quit out...

      return

      end

      function rapfact(n)

C*************************************
C
C This little routine returns n factiorial.
C If n is negative, the result returned is
C zero - this does not represent the real
C value n!, but acts as a flag value, since
C n! for integer n<0 is infinite. Note that
C the factorial is chosen to be double precision
C rather than integer due to the very large 
C numbers involved in factorials
C
C Started:4/12/95
C
C (c) Richard Townsend 1995
C
C*************************************

C Turn off implicit typing

      implicit none

C Declare the passed variables

      double precision rapfact		! The factorial function
      integer n				! The value to get rapfact for

C Declare the in-program variables

      integer i				! Counter

C Abort if n<0 with rapfact=0

      if(n.lt.0) then
        rapfact=0.D0
        return
      endif

C Initialise rapfact

      rapfact=1.D0

C Loop over n times

      do i=1,n,1
        rapfact=rapfact*i
      enddo

C Return

      return

      end

      subroutine lsdvharm(m,j2,n,np,vrad,vhor,vtor,parity)

C*******************************************************
C
C This subroutine sets up the radial, horizontal and
C toroidal expansion vectors for use by the lsd function
C routines, as they would be for a spehrical harmonic of
C m-value m, j-value j2 and parity parity.
C 
C Started:4/12/95
C
C (c) Richard Townsend 1995
C
C********************************************************

      implicit none

C Declare the passed parameters

      integer m			! The m-value to do the vectors for
      integer j2 		! The j-value to do the vectors for
      integer n			! The dimension of the vectors
      integer np		! The physical dimentsion of the vectors
      double precision vrad(np)	! The radial expansion vector
      double precision vhor(np) !The horizontal expansion vector
      double precision vtor(np) ! The toroidal expansion vector (all zeros)
      logical parity   ! The parity of the mode to do

C Declare the in-program variables
 
      integer j			! Counter to loop through the vectors
      integer am		! The absolute value of m
      double precision parfac   ! The partial factorial function (l+|m|)...(l-|m|)

C Set up am=|m|

      am=iabs(m)

C Loop over j to get the coefficients...

      do j=1,n

C If j=j2, set the vectors up as usual - otherwise, zero them

      if(j.eq.j2) then

C We set the jth coefficient, depending on whether the parity
C is even (.true.) or false (.odd.)

        if(parity) then
          vrad(j)=
     :      dsqrt((am+2*(j-1)+0.5D0)/
     :      parfac(am+2*(j-1),am))
          vhor(j)=vrad(j)
          vtor(j)=0.D0
        else
          vrad(j)=
     :      dsqrt((am+2*(j-1)+1.5D0)/
     :      parfac(am+1+2*(j-1),am))
          vhor(j)=vrad(j)
          vtor(j)=0.D0
        endif

      else
        vrad(j)=0.D0
        vhor(j)=0.D0
        vtor(j)=0.D0
      endif

C Its as simple as that - now loop back around....

      enddo

C At a little safety check, we zero all of the remaining coeffs...

      do j=n+1,np
        vrad(j)=0.D0
        vhor(j)=0.D0
        vtor(j)=0.D0
      enddo

C Thats all folks - return...

      return

      end

      subroutine lsdvtor(vtor,m,nu,eigval,n,np,
     :                  bvec,parity)

C***************************************************
C
C This subroutine sets up a vector vhor which is used as
C a set of expansion coefficients in the calculation
C of returns the toriodal velocity function of
C Lee * Saio's Lambda basis (ApJ 1990). The toroidal velocity field
C of an NRP eigenstate is then the curl
C of this function.
C The routine uses the eigenvector for the mode in question bvec,
C and also the eigenvector eigval.
C See lsdftor for details...
C
C Started:3/7/95
C Modified:4/12/95
C
C (c) Richard Townsend 1995
C
C*****************************************************

      implicit none		! Turn off implicit typing

C Declare the passed variables

      double precision eigval	! The eigenvalue corresponding to bvec
      double precision nu	! The roation parameter to use
      integer m			! The m-value to use
      integer n			! The number of terms to sum over
      integer np		! The total size of bvec
      double precision bvec(np)	! The column vector containg the eigenvector
      double precision vtor(np) ! The column vector to contain the expansion coefficients
      logical parity		! The parity to be used - .true.=even

C Declare the in-program variables

      integer j			! The coefficient index counter
      integer kj		! =|m|+2(j-1), used to simplify stuff
      integer am		! The absoulte value of m
      double precision parfac	! The partial factorial (l+|m|)...(l-|m|+1)
      double precision lsdJml	! The external Jml function

C Set up am=|m|
                             
      am=iabs(m)      

C First initialise the coefficients. We have to do the
C j=1 case separately because the general term for the coeffs
C involves bvec(j-1), which is undefined for j=1.

      if(parity) then
        vtor(1)=eigval*(bvec(1)/(am*(am+1))*nu*am/(am+1)*
     :          lsdJml(m,am+1) + bvec(2)/((am+2)*(am+3))*nu*
     :          (am+3)/(am+2)*lsdJml(m,am+2) )/ 
     :          (1-m*nu/((am+1)*(am+2)) )*
     :          dsqrt((am+1.5D0)/
     :          parfac(am+1,am))
      else
       vtor(1)=eigval*(bvec(1)/((am+1)*(am+2))*nu*
     :          (am+2)/(am+1)*lsdJml(m,am+1) )/
     :          (1-m*nu/(am*(am+1)) )*
     :          dsqrt((am+0.5D0)/
     :          parfac(am,am))
      endif

C And now loop over j to get the other coeffs (except for the last bit)

      do j=2,n-1

        kj=am+2*(j-1)

       if(parity) then
         vtor(j)=eigval*( bvec(j)/((am+2*(j-1))*
     :    (am+2*(j-1)+1))*nu*kj/(kj+1)*
     :    lsdJml(m,kj+1) + bvec(j+1)/
     :    ((am+2*j)*(am+2*j+1))*nu*(kj+3)/
     :    (kj+2)*lsdJml(m,kj+2) )/
     :    (1-m*nu/((am+1+2*(j-1))*
     :    (am+2+2*(j-1))) )*
     :    dsqrt((am+2*(j-1)+1.5D0)/
     :    parfac(am+1+2*(j-1),am))
        else
          vtor(j)=eigval*( bvec(j)/((am+1+2*(j-1))*
     :     (am+2+2*(j-1)))*nu*(kj+2)/(kj+1)*
     :     lsdJml(m,kj+1) + bvec(j-1)/
     :     ((am+2*(j-2)+1)*(am+2*(j-2)+2))*nu*(kj-1)/
     :     kj*lsdJml(m,kj) )/
     :     (1-m*nu/((am+2*(j-1))*
     :     (am+1+2*(j-1))) )*
     :     dsqrt((am+2*(j-1)+0.5D0)/
     :     parfac(am+2*(j-1),am))
        endif

C Its as simple as that - now loop back around....

      enddo

C Now do the final bit of the sum - check that j=n first

      j=n

C Do the stuff, cutting out the bit with bvec(j+1)

        kj=am+2*(j-1)

       if(parity) then
         vtor(j)=eigval*( bvec(j)/((am+2*(j-1))*
     :    (am+2*(j-1)+1))*nu*kj/(kj+1)*
     :    lsdJml(m,kj+1) )/
     :    (1-m*nu/((am+1+2*(j-1))*
     :    (am+2+2*(j-1))) )*
     :    dsqrt((am+2*(j-1)+1.5D0)/
     :    parfac(am+1+2*(j-1),am))
        else
          vtor(j)=eigval*( bvec(j)/((am+1+2*(j-1))*
     :     (am+2+2*(j-1)))*nu*(kj+2)/(kj+1)*
     :     lsdJml(m,kj+1) + bvec(j-1)/
     :     ((am+2*(j-2)+1)*(am+2*(j-2)+2))*nu*(kj-1)/
     :     kj*lsdJml(m,kj) )/
     :     (1-m*nu/((am+2*(j-1))*
     :     (am+1+2*(j-1))) )*
     :     dsqrt((am+2*(j-1)+0.5D0)/
     :     parfac(am+2*(j-1),am))
        endif

C As a final check, we zero all the other coeffs..

        do j=n+1,np
          vtor(j)=0.D0
        enddo

C Thats all folks - return...

      return

      end

      function lsdfrad(m,ctheta,n,np,vrad,parity)

C********************************************************
C
C This function returns the function Psquiggle(m,lj)
C for use in the new Lambda Basis of Lee & Saio (1990)
C 349, 570-579. This function is a sum over n Associated
C Legendre polynomials of constant m-value and and l value
C given by lj=|m|+2(j-1) for parity=.true. (even modes)
C and by lj=|m|+1+2(j-1) for parity=.false. (odd modes),
C where j goes from 1 to d. The sum is weighted by coefficents
C vrad which are held in an array of physical size np and
C logical size n. This array is previously calculated by the
C funtion lsdvrad. Since Psquiggle is a function of the associated
C Legendre polynomials, it also obviously depends upon theta,
C the 'colatitude'.
C
C Note that cos theta MUST NOT EXCEED +/-1 or this routine will
C bum out.
C
C The m=0 screw-up experienced previously should be fixed by now...
C
C This routine now adheres to the Condon & Shortley phase convention
C
C Started:29/3/95
C Updated:6/12/95
C
C (c) Richard Townsend 1995
C
C************************************************************

      implicit none		! Turn off implicit typing

C Declare the passed variables

      double precision lsdfrad	! The returned function
      double precision ctheta	! The cosine of the theta value to use
      integer m			! The m-value to use
      integer n			! The number of terms to sum over
      integer np		! The total size of vrad
      double precision vrad(np)	! The column vector containg the coefficients
      logical parity		! The parity to be used - .true.=even

C Declare the in-program variables

      integer j			! The summation counter
      integer lj    		! Holds l-values for Pml's
      integer am		! The absoulte value of m
      integer CSphas		! The Condon & Shortley phase adjustor
      double precision Pml	! The value of the Assoc. Leg. Poly, l=lj
      double precision Pml1	! The value of the Assoc. Leg. Poly, l=lj+1
      double precision Pml2	! The value of the Assoc. Leg. Poly, l=lj+2
      double precision stheta	! Sine of theta
      double precision oddfac	! The product of all odd integers lt (2m-1)

C Set up am=|m|
   
      am=iabs(m)      

C Set up CSPhas

      CSPhas=(-1)**((am-m)/2)

C Initialise the staring values of Pml and Pml1
C oddfac has to be used along the way for Pml - see
C Numerical Recipies 2nd Ed p247

      stheta=dsqrt((1.D0-ctheta)*(1.D0+ctheta))
      oddfac=1.D0

      Pml=1.D0

      if (am.gt.0) then

        do j=1,am
          Pml=-Pml*oddfac*stheta
          oddfac=oddfac+2.D0
        enddo

      endif

C Fix the phase to that of Condon & Shortley

      Pml=Pml*CSPhas

C Set up Pml1

      Pml1=ctheta*(2*am+1)*Pml

C First initialise the total sum.

      if(parity) then
        lsdfrad=vrad(1)*Pml
      else
        lsdfrad=vrad(1)*Pml1
      endif

C And now loop over j to get the rest of the sum...

      do j=2,n

C Update Pml - first get the l-value for this update,
C and then bung its new value into Pml. 

        lj=am+2*(j-1)

        Pml=(ctheta*(2*lj-1)*Pml1
     :      -(lj+am-1)*Pml)/(lj-am)

C Now update the value of Pml1, again doing lj

        lj=am+1+2*(j-1)

        Pml1=(ctheta*(2*lj-1)*Pml
     :       -(lj+am-1)*Pml1)/(lj-am)

C Now we add in the appropiate term to the sum, depending
C on the parity...

        if(parity) then
          lsdfrad=lsdfrad+vrad(j)*Pml
        else
          lsdfrad=lsdfrad+vrad(j)*Pml1
        endif

C Its as simple as that - now loop back around....

      enddo

C Thats all folks - return...

      end

      function lsdpythag(a,b)
      double precision a,b,lsdpythag
      double precision absa,absb
      absa=dabs(a)
      absb=dabs(b)
      if(absa.gt.absb)then
        lsdpythag=absa*dsqrt(1.D0+(absb/absa)**2)
      else
        if(absb.eq.0.D0)then
          lsdpythag=0.D0
        else
          lsdpythag=absb*dsqrt(1.D0+(absa/absb)**2)
        endif
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software )$(.

      SUBROUTINE DTOUPP(STRING)
      CHARACTER STRING*(*)
      INTEGER I
      INTEGER LENSTR, NEWCH
      CHARACTER CHA*1
      LENSTR=LEN(STRING)
      DO 1 I=1,LENSTR
        CHA=STRING(I:I)
        IF ( LGE(CHA,'a') .AND. LLE(CHA,'z') ) THEN
          NEWCH=ICHAR(CHA)+ICHAR('A')-ICHAR('a')
          STRING(I:I)=CHAR(NEWCH)
        END IF
    1 CONTINUE
      END

      function bgetmax(nuGmax,HGMax,MGmax,JGmax,PGmax)

C***********************************************************
C
C This function takes a set of individual mode parameters
C for a given mode and returns the PEAK velocity
C amplitude which that mode will ever produde, for a mathematical
C amplitude of 1m/s. This peak is taken as MAX(radial velocity,
C horizontal velocity).
C
C  Input parameters:
C   
C    nuGmax 	:	mode rotation parameter
C    HGMax	:	mode K value
C    MGmax 	:	mode m value
C    JGmax	:	mode J value
C    PGmax	:       mode parity
C
C Started       :15/4/96
C Modified :
C
C  22/06/00 - Changed HGMax to HGmax (horizontal amplitude)
C
C  26/06/00 - Modified the code to check whether horizontal
C             velocity fields are being included
C
C (c) Richard Townsend 1996
C
C***********************************************************

C Turn off implicit typing

      implicit none

C Define the hard-wired parameters

      include "bruce.compar_define.inc"

C *** Start of Include block load ***

C Load in the stellar parameters common block

      include "bruce.stepar_common.inc"

C Load in the equilibrium Stellar grid common block

      include "bruce.eqstgr_common.inc"

C Load in the field switches common block

      include "bruce.fldswi_common.inc"

C LOad in the angles and constants include file

      include "angles.inc"

      include "constants.inc"

C *** End of Include Block Load ***

C Declare the passed variables
      
      double precision bgetmax	        ! The returned maximum velocity
      double precision nuGmax		! The rotation parameter of a given mode
      double precision HGMax		! The relative horizontal amplitude to use
      integer MGmax			! The m-value to find the velocity for
      integer JGmax			! The j-value to find the velocity for
      logical PGmax                	! The parity to find the velocity for

C Declare the variables used by the Lee & Saio routines

      double precision DVec(DimMax)	! The diagonal components of the W-matrix & eigenvalues
      double precision SVec(DimMax)     ! The off-diagonal components of the W-matrix
      double precision Emat(DimMax,DimMax) 	! Matrix to hold the eigenvectors found
      double precision RadVec(DimMax)		! Vector holding the radial expansion coeffs
      double precision HorVec(DimMax)		! Vector holding the horizontal expansion coeffs
      double precision TorVec(DimMax)		! Vector holding the toroidal expansion coeffs
      integer EgIndx(DimMax) 		! Array for sorting the eigenvalues
      integer ISign			! Counter for adjusting the sign of the eigenvectors
      double precision lsdFRad		! The function to return the Lee & Saio radial function
      double precision lsdFHor		! The function to return the Lee & Saio horizontal function
      double precision lsdFTor		! The function to return the Lee & Saio toroidal function
      double precision lsdFDRad		! The function to return d/dtheta of the Lee & Saio radial function
      double precision lsdFDHor		! The function to return d/dtheta of the Lee & Saio horizontal function
      double precision lsdFDTor		! The function to return d/dtheta of the Lee & Saio toroidal function
 

C Declare the variables used in the grid calculations

      double precision theta           ! The value of theta for some grid point
      double precision ctheta          ! Cosine of theta
      double precision stheta          ! Sine of theta
      double precision rtheta	       ! The reciprocal of stheta
      double precision phi	       ! The value of phi for some grid point
      double precision cosMP	       ! The cosine of m*phi
      double precision sinMP           ! The sine of m*phi
      double precision cnorm	       ! The colatitude normalisation factor (see later)
      double precision RBasis          ! The value of the radial basis function |lambda> at some theta
      double precision pVRad           ! The partial (theta-part) radial velocity for a given mode
      double precision pVThe           ! The partial (theta-part) theta velocity for a given mode
      double precision pVPhi           ! The partial (theta-part) phi velocity for a given mode
      double precision VRad	       ! The radial velocity
      double precision VThe	       ! The theta-velocity
      double precision VPhi            ! The phi velocity
      double precision VMod	       ! The modulus of the velocity

C Declare the variables used for general control

      logical ok                       ! Status flag for some of the subroutines called
      integer gcount                   ! Counter to step through the partial grid points (ie theta)
      integer pcount		       ! Counter to step through phi
      integer NGPhi	               ! The number of grid points at a given theta

C Depending on we are using Lee & Saio stuff, we find the W-matrix
C for the mode and diagonalise it etc...

      if(LSDEff) then

C Do matrix stuff...

C Call the first of the Lee & Saio LSD routines to generate the W-matrix.
C If the generation is sucessful, continue, otherwise write out an error
C message.

        call lsdMakeW(MGmax,nuGmax,PGmax,
     :                MatDim,DimMax,DVec,SVec,ok)

        call lsdTQLI(DVec,SVec,MatDim,DimMax,EMat)

        call lsdFindE(MGmax,nuGmax,MatDim,
     :                DimMax,DVec,SVec,EgIndx,
     :                PGmax)

        if(EMat(JGmax,EgIndx(JGmax)).lt.0.D0) then
            do ISign=1,MatDim
              EMat(ISign,EgIndx(JGmax))=
     :       -EMat(ISign,EgIndx(JGmax))
            enddo
        endif
 
        call lsdVRad(RadVec,MGmax,MatDim,DimMax,
     :               EMat(1,EgIndx(JGmax)),
     :               PGmax)

        call lsdVHor(HorVec,MGmax,
     :               1.D0/DVec(EgIndx(JGmax)),
     :               MatDim,DimMax,
     :               EMat(1,EgIndx(JGmax)),
     :               PGmax)

        call lsdVTor(TorVec,MGmax,nuGmax,
     :               1.D0/DVec(EgIndx(JGmax)),
     :               MatDim,DimMax,
     :               EMat(1,EgIndx(JGmax)),
     :               PGmax)

      else

        call lsdVharm(MGmax,JGmax,MatDim,DimMax,
     :      RadVec,HorVec,TorVec,
     :      PGmax)

      endif

C OK, now we loop over theta (ie the stellar grid) to find the maximum velocity. First
C we initialise the max velocity to be zero:

      bgetmax=-1.D20

C Now we can loop through the theta-part of the stellar grid to find the maximum and
C minimum velocity amplitude for this mode.

      do gcount=1,NGrid,1

C Work out theta for this grid point

        theta=(gcount-0.5D0)/dble(NGrid)*D90

C Get the theta-part of Vr, Vtheta and Vphi for this mode. To do the calculations, we first set up
C ctheta with the value of cos(theta), & stheta with sin(theta). This part is lifted straight
C from the main routine bruce.f; see the corresponding bit in bruce.f for a bit more documentation.

        ctheta=cos(theta)
        stheta=sin(theta)
        rtheta=1.D0/stheta

        if (ColNrm) then
          cnorm=RGrid(gcount)/Rpole
        else
          cnorm=1.D0
        endif

C Set up the theta part of the radial basis state in RBasis

        RBasis=RecpPi*
     :        lsdFRad(MGmax,ctheta,MatDim,DimMax,
     :         RadVec,PGmax)

C Use RBasis to get the radial velocity VRad (amplitude 1)

        pVRad=RBasis*cnorm

C Get the horizontal fields

        pVThe=RecpPi*HGMax*(
     :         lsdFDHor(MGmax,ctheta,MatDim,DimMax,
     :          HorVec,PGmax) +
     :         lsdFTor(MGmax,ctheta,MatDim,DimMax,
     :          TorVec,PGmax)*MGmax*rtheta )*
     :         cnorm

        pVPhi=-RecpPi*HGMax*(
     :         lsdFHor(MGmax,ctheta,MatDim,DimMax,
     :          HorVec,PGmax)*MGmax*rtheta +
     :         lsdFDTor(MGmax,ctheta,MatDim,DimMax,
     :          TorVec,PGmax) )*
     :          cnorm


C Work out the number of phi grid points at this latitude...

        NGPhi=int(NEqtr*sin(theta))+1

C Loop over phi...

        do pcount=1,NGPhi,1

C Work out the phi of this point, and trig functions associated with it

          phi=(pcount-0.5D0)/dble(NGPhi)*D360
        
C Work out the cos and sine bitz

          cosMP=cos(MGmax*phi)
                        
          sinMP=sin(MGmax*phi)

C Update the net values defined above for the grid point

          VRad=pVRad*cosMP
          VThe=pVThe*cosMP
          VPhi=pVPhi*sinMP

C Work out the velocity modulus...

          if(HorEff) then
             VMod=sqrt(VRad**2+VThe**2+VPhi**2)
          else
             VMod=abs(VRad)
          endif

C Update the maximum velocity
         
          bgetmax=max(bgetmax,VMod)

C Loop back around....

        enddo
           
      enddo


C Return to the caller...

       return

       end

      SUBROUTINE SSTRIP(STRING)
C
C Subroutine to strip leading spaces from a character string
C
      CHARACTER STRING*(*)
      INTEGER I
      IF ( STRING.NE.' ' ) THEN
        I=1
10000   IF ( STRING(I:I).EQ.' ' ) THEN
          I=I+1
          GOTO 10000
        END IF
        STRING=STRING(I:)
      END IF
      END

      subroutine lsdvrad(vrad,m,n,np,bvec,parity)

C********************************************************
C
C This subroutine sets up a vector vrad which is used as
C a set of expansion coefficents in the calculation of
C the function Psquiggle(m,lj) in the routine lsdfrad
C for use in the new Lambda Basis of Lee & Saio (1990)
C 349, 570-579. The routine uses the eigenvector for the
C mode in question bvec, which is found previously using lsdtqli
C See lsdfrad for details...
C
C Started:3/7/95
C Updated:
C
C (c) Richard Townsend 1995
C
C************************************************************

      implicit none		! Turn off implicit typing

C Declare the passed variables

      integer m			! The m-value to use
      integer n			! The number of terms to calculate over
      integer np		! The total size of bvec
      double precision bvec(np)	! The column vector containing the appropiate eigenvector
      double precision vrad(np) ! The column vector to contain the expansion coefficients
      logical parity		! The parity to be used - .true.=even

C Declare the in-program variables

      integer j			! The coefficient index counter
      integer am		! The absoulte value of m
      double precision parfac	! The partial factorial (l+|m|)...(l-|m|+1)

C Set up am=|m|
   
      am=iabs(m)      
 
C Loop over j to get the coefficients...

      do j=1,n

C We set the jth coefficient, depending on whether the parity
C is even (.true.) or false (.odd.)

        if(parity) then

          vrad(j)=bvec(j)*
     :      dsqrt((am+2*(j-1)+0.5D0)/
     :      parfac(am+2*(j-1),am))
        else

          vrad(j)=bvec(j)*
     :      dsqrt((am+2*(j-1)+1.5D0)/
     :      parfac(am+1+2*(j-1),am))
        endif

C Its as simple as that - now loop back around....

      enddo

C At a little safety check, we zero all of the remaining coeffs...

      do j=n+1,np
        vrad(j)=0.D0
      enddo

C Thats all folks - return...

      return

      end

      subroutine lsdmakeW(m,nu,parity,matdim
     :                   ,dimmax,dvec,svec,ok)

C *****************************************************************
C
C This subroutine MAKEW generates the inverse of the matrix W which
C appears in the equations of Lee & Saio. The elements of W^-1 can be
C found their paper MNRAS (1987) 221, 513-526. The matrix is symmetric
C and tridiagonal, so that we only need to define the diagonal and
C sub-diagonal elements dvec() and svec(). svec(1) is undefined. The
C matrix to be generated is of logical size n and physical size nd.
C m and nu are parameters which govern the state of the matrix - m can
C be any integer (except zero), and nu can be any number. The logical
C variable parity governs whether the matrix is generated for even
C or odd modes - .true. gives even modes, and .false. gives odd modes.
C Sometimes W^-1 has singular elements; this is checked for, and when
C it occurs, the returned statues flag ok is .false.; otherwise,
C ok is .true.
C
C (c) Richard Townsend 1995
C
C*******************************************************************

      implicit none	! Turn off implicit typing

C Declare the passed variables

      integer m		! The m-value to make the matrix for
      double precision nu  	! The nu (rotation parameter) to use
      logical parity	! Whether the matrix is for even or odd modes
      integer matdim	! The logical dimension of the matrix to make
      integer dimmax	! The physical dimension of the matrix to make
      double precision dvec(dimmax)	! The diagonal matrix elements
      double precision svec(dimmax)	! The sub-diagonal matrix elements
      logical ok	! The returning status flag

C Declare the in-program variables

      integer j		! A counting variable which steps over l-values
      integer lj	! The l-value associated with each value of j 
      double precision lsdFl   	! Lee & Saio's F(l) function - see MNRAS 221
      double precision lsdJml   ! Lee & Saio's Jml(m,l) function  - "

C Initialise the returning status flag to .true. (ie no error)

      ok=.true.

C Set up the values of lj for j=1; we only need to set up lj once by
C discriminating whether parity is .even. or .odd., since after that,
C l(j+1)=l(j)+2 always...

      if(parity) then
        lj=abs(m)
      else
        lj=abs(m)+1
      endif

C Now we loop over all of the matrix elements (diagonal) except the last...

      do j=1,matdim-1

C Work out if the matrix is going to go singular. This will happen when
C m*nu=lj(lj-1) (except for j=1,even modes) or m*nu=(lj+1)(lj+2). If this
C occurs, bum out with a .false. value in ok. We only need to check the
C lj(lj-1) singularity for odd modes, since the (lj+1)(lj+2) check will
C pick up all the even-mode singularities.

C        if(m*nu.eq.dble(lj*(lj-1)).and.parity.eq..false.) then
C          ok=.false.
C          goto 9000
        if(m*nu.eq.dble((lj+1)*(lj+2))) then
          ok=.false.
          goto 9000
        endif

C Set up the matrix elements.

        dvec(j)=(1.D0 - m*nu/(lj*(lj+1))
     :             - nu**2 * lsdFl(m,lj,nu))/(lj*(lj+1))

        svec(j+1)=-nu**2 * lsdJml(m,lj+1) * lsdJml(m,lj+2) /
     :           ((lj+1)*(lj+2)-m*nu)

C Increment lj

        lj=lj+2

C ...and loop around.

      enddo

C Do the last diagonal element, again checking for singularities. In this
C case, the singularities will only be generated by the m*nu=(lj+1)(lj+2)
C term, so we only need to check for that...
 
      if(m*nu.eq.dble((lj+1)*(lj+2))) then
        ok=.false.
        goto 9000
      endif

C Now we set up the last matrix element in the usual way...

      dvec(matdim)=(1.D0 - m*nu/(lj*(lj+1))
     :           - nu**2 * lsdFl(m,lj,nu))/(lj*(lj+1))

C Finshed, so we quit...

 9000 continue

      return

      end

      program bruce

C***********************************************************
C
C This is the all-new, memory-friendly version of bruce, a
C program designed to work out the velocity & temperature
C fields of a rotating non-radially pulsating star. Originally,
C bruce went on to produce theoretical spectra using Keith Smith's
C tgprof3 routine. However, this routine requires about 150Mb
C in memory to run, which was unacceptable. Accordingly, bruce
C now does not write out any spectra information; instead, a
C set of files is written containing the temperature, (projected) velocity,
C gravity, area and mu (cos theta) of all the points on the stellar
C grid visible to the observer. Note that no more information
C is required to construct spectra; theta/phi information is
C unnessecary. These raw dump files have names specified by the
C convention <filestub>XXX where <filestub> is a user-specified
C prefix to the filename and XXX is the field number of the dump
C file (ie position in the run of field calculations). The
C parameters which bruce uses are read in from a file pointed
C to by the environment variable BRUCE_PARAMS. When this input
C file is parsed, a load of diagnostic information is printed out,
C along with useful bits and pieces like who is running the code.
C
C
C Started (original bruce):?
C Started (this bruce    ):21/9/95
C Last Modified           :29/11/00
C
C Modifications:
C
C  10/10/95 - The phi component of the observer vector had the wrong sign (
C             it was positive rather than negative), leading to very 
C             peculiar output. Fixed
C
C  11/10/95 - bmakeg now works out the number of visible points on the star,
C             which does not change with time. This is written out first to
C             all raw files so that kylie will 'know' how many quints to read
C             in - much better than waiting for eof. Also written out in the
C             header is the time of the calculation.
C           - the .kylie.com file is no longer used - instead, kylie is just 
C             supplied with a number of fields and a filestub and works it all
C             out from there. This is because
C           - the start_field and end_field commands are no longer implemented,
C             since they were a bit of a kludge
C           - raw files are not now $$$$$$.raw.XXX but $$$$$$XXX
C	    - I've increased the size of string from 40 to 80 coz it seemed a bit small
C
C  4/12/95  - Off-axis modes can now be produced. Basically, any off axis mode with
C             parameters l,m may be written as a sum of on-axis modes with parameters
C             l and m'=-l...+l. To use off-axis modes, firstly, the POLAR_AXIS_OFFSET
C             parameter must appear in the #Stellar command specifying the angle between
C             the rotation axis and the polar axis (in degrees). Then, one must define
C             a mode for every m' required in the sum above and include in each #Mode 
C             command the parameter OFFSET_M_VALUE specifying the value of m each mode
C             is supposed to make an off-axis mode for. Obviously, doing off-axis modes
C             requires many more mode definitions, so maxmde has been upped to 20.
C           - The off-axis calculations have an inherent problem: since they invariably
C             involve an m=0 mode, there are problems generating a W matrix for such a
C             mode. For m=0 modes, the W-matrix will contain l=0 terms which generate
C             singularities whilst doing the matrix generation - this causes the program to
C             crash. Consequentially, an explicit check is made to see if lsdeff is true or false,
C             and when it is false, the expansion vectors are set up properly, coping with m=0 modes,
C             (which the Lee & Saio theory cannot handle anyway), and blojob has been modified so
C             that off-axis modes and Lee & Saio modes are mutually exclusive. The expansion vectors
C             are set up using the new routine lsdvharm, which sets radvec and horvec to be the
C             spherical harmonic normalizing factor x delta(j_mode,j_vector); torvec is set to 0. 
C
C  6/12/95  - The off-axis calculation seems to be working (sort of). Note that to get an off-axis
C             mode, all of the contributing modes must have the same *corotating* frequency - not
C             the same observer's or super- period, as one may think. However, there is a possible
C             problem - I think there might be an anomalous 180 deg phase shift on the position
C             of the off-axis mode axis. To help correct this, bruce now AUTOMATICALLY writes
C             out auxilary file with the format $$$$$$XXX.aux which contain Theta, Phi, Inclination,
C             VRad, VProj and Temp. information, which may be used to construct a graphical image of the star
C             These new files have a new file handle ahandl
C
C           - New Note: The writing out of the aux files seems to work, and has confirmed that the angle
C             of the off-axis is out by 180 degs. I suspect this is because my routines do not adhere to
C             the Condon & Shortley phase convention, so they do now! Fingers crossed....and it works -whew!
C
C           - New note: R/REq is written out to the auxilary files, becuase of course the star is not a sphere,
C             rather an oblate spheroid. To allow the programs which deal with the aux files to mark the pole,
C             Rpole/REq is now also written out, in the header.
C
C  7/12/95  - Done some tidying up to the new off-axis code and the new auxilary files. The aux files no
C             longer have the field time written out in the header (it is unnecessary), and they are not
C             automatically written out; in the fields command, there is a new parameter WRITE_AUX_FILES
C             which instructs bruce to write out aux files with the naming convention above; if this parameter
C             is not present, aux files will not be written out. For the off-axis stuff, I have changed
C             the names of the commands to correspond to roAp models.
C
C  12/2/96  - Changed the format specifier in the output stuff for velocity coz it woz overflowing
C
C  15/4/96  - Added a routine (lsdgetmax) and some stuff in blojob so that by specifying the
C             PHYSICAL_AMPLITUDES fields option, the amplitudes are taken to be physical peak amplitudes
C             rather than mathematical amplitudes. This is achieved for each mode individually by
C             dividing the user's amplitude by the maximum physical amplitude of a pulsation with
C             mathematical amplitude 1. By maximum, I do max(Radial,Theta,Phi) at each colatitude, so
C             it is not maximum in the strictest sense of the word.
C
C  20/5/96  - Modified lsdgetmax. Originally, the velocities were normalized by the largest of the
C             radial, theta and phi velocities. However, this normalisation is not a smooth function
C             of K, and introduces structure where there is none. Accordingly, each mode is normalised
C             by the maximum velocity MODULUS over the stellar surface.
C
C  4/9/96   - Allowed the user to specify the degree of gravity darkening using the ZEIPEL_BETA parameter
C             in the #STELLAR command. The value defaults to 0.25
C
C  2/26/97  - The temperature effects have been modified to take into account the Lee&Saio stuff. Also,
C             the Lee&Saio: parameter has been changed to the MATRIX_DIMENSION: parameter,
C
C  5/5/97   - Removed all DEC Fortran stuff, and modified the source so that parameter
C             files are read in from standard input
C
C  18/7/97  - Moved all lsd routines to separate lsd library, and renamed lsdgetmax to bgetmax
C
C  31/7/97  - Version 2.71 released
C
C  12/8/97  - I discovered today that there is a small error in the bruce
C             user manual (section F.2 of my thesis). The parameter
C             "use_mode_parameter" in the #timings command description
C             should read "use_mode_period".
C
C  12/8/97  - I also found out (thanks to an observant user) today that the 
C             "stellar_mass" parameter led to a run-time error. Upon inspection,
C             I have discovered that the code dealing with it was broken, as
C             was the code for the "polar_mks_gravity", so I fixed everything.
C             Note that these bugs just stopped bruce from running - they didn't
C             lead to erroneous results.
C
C  23/12/98 - Added a new TIMINGS parameter INCLUDE_ENDPOINTS which signifies that start and end spectra
C             should be calculated at the start and end times, and equally spaced between, rather than
C             calculated at the mid-points of equal-sized time-chunks. The latter puts the start and end
C             spectra half a time-step in from the time endpoints, and is the "traditional" behaviour.
C
C  23/12/98 - Added a new TIMINGS parameter WRITE_TIMINGS_FILE which signifies that a space-separated
C             list of dump files and their times should be written to the file $$$$$$$.times
C
C  25/1/99  - Added a new TIMINGS parameter TIMINGS_FROM_FILE which allows the times of all the field
C             calculations to be specified in a file as a list. The argument of the parameter is the
C             file name. Note that this is separate from WRITE_TIMINGS_FILE, which is for writing
C             times OUT rather than reading them in. This parameter is exclusive with START_TIME,
C             FINISH_TIME, INCLUDE_ENDPOINTS and NUMBER_OF_FIELDS, since the file contains all
C             of this information. This change has made it necessary to now store all field times
C             in the array Times, which is set up in blojob.f.
C
C  25/1/99  - Version 2.8 released
C
C  18/2/99  - Added in stuff to indicate the maximum size of radius variations for each field
C             This required a new variable - dRMax
C
C  18/2/99  - Added in stuff to indicate the maximum size of temperature for each field
C             This required a new variable - dTMax
C
C  14/6/99  - Added a new MODE parameter HORIZONTAL_PHASE_SHIFT to allow phase shifts in the horizontal 
C             velocity fields to be modelled (this is primarily for simulations of wave leakage)
C
C  14/6/99  - Changed the reporting information written out, so that the effective temperature
C             (=(Luminosity/(Sigma*Area))**0.25) is printed instead of the equal volume radius
C
C  13/10/99 - Radically changed the reporting used in breprt() to use FORMAT statements rather than
C             character constants, in order to make the code more portable. Also moved various 
C             output statements around in this file
C
C  22/05/00 - Deleted the variable AAmode, and introduced a new one in its place - TAmode.
C             This gives the amplitude of fractional temperature perturbations (when combined
C             with the angular basis function RBasis). If it is zero, then the original
C             Buta & Smith (1979) expression is used to calculate the amplitude (the original
C             behaviour). The command language has been modified accordingly - instead of
C             using NA_AMPLITUDE_SHIFT, use TEMPERATURE_AMPLITUDE. Temperature perturbations 
C             can be turned off completely by *not* specifying the TEMPERATURE_EFFECTS
C             parameter
C
C  22/05/00 - The variable APmode (non-adiabatic temperature phase shift) has been renamed
C             to TPmode ("temperature-phase"), and the parameter NA_PHASE_SHIFT has been
C             renamed to TEMPERATURE_PHASE
C
C  22/05/00 - Changed the way the horizontal velocity fields are handled, to bring them in
C             line with the way temperature perturbations are handled. The new variable HAmode
C             gives the amplitude of horizontal velocity fields (when combined with the
C             angular basis functions). If it is zero, then the amplitude is taken from the
C             value of K. To set HAmode, use the HORIZONTAL_VELOCITY_AMPLITUDE parameter. Horizontal
C             velocity fields can be turned off completely by *not* specifying the 
C             HORIZONTAL_VELOCITY_FIELDS parameter. Note that this functionality replaces
C             that originally offfered by the K_VALUE_OVERRIDE parameter; the latter has
C             been deleted.
C
C  22/05/00 - Renamed the HORIZONTAL_PHASE_SHIFT parameter to HORIZONTAL_VELOCITY_PHASE, to
C             bring it in line with the way temperature perturbations are handled
C
C  25/05/00 - Removed the PERIOD_FROM_NU parameter, and replaced it by the NU parameter, which
C             just fundges the adopted value of NU; this involdes the new variable numode. If
C             numode is zero, the nu is calculated using the usual expression nu=2Omega/omega.
C             Rotational effects can be turned off completely by *not* specifying the
C             MATRIX_DIMENSION parameter
C
C  08/06/00 - Noticed that, somewhere along the way, TIMINGS_FROM_FILE (see above) has been
C             renamed to READ_TIMINGS_FILE - oops!
C
C  08/06/00 - Changed the way field calculations are reported in the output
C
C  19/06/00 - Version 2.83-1 released
C
C  24/07/00 - Altered the interpretation of TEMPERATURE_AMPLITUDE. Previously, it meant the
C             relative amplitude of temperature perturbations; now, it acts as a conversion
C             factor between the fractional radius and temperature perturbation amplitudes.
C             Basically, it is the equivalent of the dR/R coefficient in the Buta & Smith
C             adiabatic dT/T expression
C
C  03/08/00 - Discovered two errors in the lsdfdhor.f/lsdfdtor.f functions of the liblsd 
C             library. These functions calculate the derivatives with respect to theta
C             of the lsdfhor.f (horizontal displacement) and lsdftor.f (toroidal displacement)
C             functions, respectively. The first error led to incorret results for (l>0,m=0) modes,
C             whilst the second led to incorrect results for all (l-|m|>0) modes. I've verified
C             that the functions now work for l<=4 modes (and there is no reason to expect
C             that they won't work for ALL modes). The physical implications of the errors
C             were erroneous horizontal velocity field eigenfunctions. Thanks to Joris
C             De Ridder for spotting the problem. I guess this goes to show that BRUCE still
C             may have bugs!
C
C  03/08/00 - Version 2.83-2 released
C
C  20/09/00 - Put in stuff to include pressure perturbation terms. These are modeled by 
C             including gravity perturbations, such that the relative Lagrangian gravity
C             perturbation is equal to the relative Lagrangian pressure perturbation.
C             Pressure perturbations are switched on by putting a PRESSURE_EFFECTS
C             term in the #fields command. The amplitude and phase of the pressure
C             perturbations, relative to the fractional radius perturbations, may be set 
C             using the PRESSURE_AMPLITUDE and PRESSURE_PHASE parameters in the #mode
C             command (analogously to temperature perturbations). If neither of these
C             are set, then Dziembowski's (1971) outer boundary condition is used to
C             get the values. New variables introduced are PAmode, PPmode, PreEff and
C             others
C
C  29/11/00 - Discovered that the fix to lsdfdhor.f and lsdfdtor.f also needed to be made
C             to lsdfdrad.f (which is used in calculating surface area/normal perturbations).
C             This means that surface area/normal perturbations were incorrect for all m=0
C             modes, and also modes with (l-|m|>0). This problem was detected because calculations
C             for m=0 modes were giving NaNs for the projected surface area of grid points.
C             These NaNs, however, only occured on a Linux box (not an Alpha), since Linux
C             g77 does not initialise variables to zero.
C
C  29/11/00 - Realised that the lsdfdhor.f/lsdfdtor.f/lsdfdrad.f problems will have affected ALL
C             modes if the MATRIX_DIMENSION parameter was specified (ie, if rotational effects
C             were used). This is because, for a mode with given m, the Coriolis force mixes in
C             modes with all values of l, including the ones which were incorrectly calculated).
C             This realization doesn't require any bug-fixes, but means that the scope of the
C             problem is much larger than previously realised. 
C
C  30/11/00 - Version 2.84-1 released
C
C  24/01/01 - Found a problem with the way area perturbations are handled in the main program
C             (bruce.f). It seems there was a missing RecpPi (=1/sqrt(2*pi)) factor on the theta-
C             component of the area perturbations, which is definitely required. Shouldn't be
C             important to spectroscopy, but introduces errors (at about a 20% level) when one
C             is doing photometry
C
C  24/01/01 - Version 2.84-2 released in light of above bug
C
C**************************************************************
C
C This program, and all associated files, is Copyright (c) Richard Townsend 1995-2001.
C Please see the COPYING file for details of this copyright, and details of
C distributing and modifying bruce. Also see the file README.
C
C**************************************************************

C Turn of implicit typing

      implicit none

C Define the hard-wired parameters
 
      include "bruce.compar_define.inc"

C *** Start of Include block load ***

C Load in the Stellar parameters common block

      include "bruce.stepar_common.inc"

C Load in the equilibrium Stellar grid common block

      include "bruce.eqstgr_common.inc"

C Load in the Mode definition common block

      include "bruce.moddef_common.inc"

C Load in the File names common block

      include "bruce.filnam_common.inc"

C Load in the Field definition common block

      include "bruce.flddef_common.inc"

C Load in the Field switches common block

      include "bruce.fldswi_common.inc"

C LOad in the angles and constants include file

      include "angles.inc"

      include "constants.inc"

C *** End of Include Block Load ***

C Declare the variables used by the lee & Saio LSD routines

      double precision nu		        ! The rotation parameter of a given mode
      double precision DVec(DimMax)	        ! The diagonal components of the W-matrix & eigenvalues
      double precision SVec(DimMax)             ! The off-diagonal components of the W-matrix
      double precision Emat(DimMax,DimMax) 	! Matrix to hold the eigenvectors found
      double precision RadVec(DimMax,maxmde)	! Vector holding the radial expansion coeffs
      double precision HorVec(DimMax,maxmde)	! Vector holding the horizontal expansion coeffs
      double precision TorVec(DimMax,maxmde)	! Vector holding the toroidal expansion coeffs
      integer EgIndx(DimMax) 		        ! Array for sorting the eigenvalues
      integer ISign			        ! Counter for adjusting the sign of the eigenvectors
      double precision lsdFRad		        ! The function to return the Lee & Saio radial function
      double precision lsdFHor		        ! The function to return the Lee & Saio horizontal function
      double precision lsdFTor		        ! The function to return the Lee & Saio toroidal function
      double precision lsdFDRad		        ! The function to return d/dtheta of the Lee & Saio radial function
      double precision lsdFDHor		        ! The function to return d/dtheta of the Lee & Saio horizontal function
      double precision lsdFDTor		        ! The function to return d/dtheta of the Lee & Saio toroidal function
 

C Declare the variables used in the grid calculations

      double precision theta           ! The value of theta for some grid point
      double precision ctheta          ! Cosine of theta
      double precision stheta          ! Sine of theta
      double precision rtheta	       ! The reciprocal of stheta
      double precision phi             ! The value of phi for some grid point
      double precision cphi            ! Cosine of phi
      double precision sphi            ! Sine of phi
      double precision cosMP           ! Cosine of a number of mode parameters (phi-part of basis)
      double precision sinMP           ! Sine of a number of mode parameters (phi-part of basis)
      double precision TsinMP          ! Sine of a number of mode parameters (phi-part of basis) for Temperature
      double precision PsinMP          ! Sine of a number of mode parameters (phi-part of basis) for Pressure
      double precision HcosMP          ! Cosine of a number of mode parameters (phi-part of basis) for Horizontal Fields
      double precision HsinMP          ! Sine of a number of mode parameters (phi-part of basis) for Horizontal Fields
      double precision cnorm	       ! The colatitude normalisation factor (see later)
      double precision dcnorm	       ! The theta-derivative of cnorm
      double precision RBasis          ! The value of the radial basis function |lambda> at some theta
      double precision pVRad(maxmde)   ! The partial (theta-part) radial velocity for a given mode
      double precision pVThe(maxmde)   ! The partial (theta-part) theta velocity for a given mode
      double precision pVPhi(maxmde)   ! The partial (theta-part) phi velocity for a given mode
      double precision pFTemp(maxmde)  ! The partial (theta-part) fractional temp variation for a given mode
      double precision pFPres(maxmde)  ! The partial (theta-part) fractional pressure variation for a given mode
      double precision pARad(maxmde)   ! The partial (theta-part) absolute radius variation for a given mode
      double precision pARad2(maxmde)  ! The derivative with respect to theta of pARad
      double precision VRad,VRadC      ! The net radial velocity at a given grid point & conjugate
      double precision VThe,VTheC      ! The net theta velocity at a given grid point & conjugate
      double precision VPhi,VPhiC      ! The net phi velocity at a given grid point & conjugate
      double precision FTemp,FTempC    ! The net fractional temperature variation at a grid point & conj
      double precision FPres,FPresC    ! The net fractional pressure variation at a grid point & conj
      double precision ARad,ARadC      ! The net absolute radius variation at a given grid point & conj
      double precision ARad2,ARad2C    ! The derivative with respect to theta of ARad/ARadC
      double precision ARad3,ARad3C    ! The derivative with respect to theta of ARad/ARadC
      double precision ObsR,ObsRC      ! The radial component of the observer at a grid point & conj
      double precision ObsT,ObsTC      ! The theta component of the observer at a grid point & conj
      double precision ObsP,ObsPC      ! The phi component of the observer at a grid point & conj
      double precision cosMu,cosMuC    ! Cosine of the angle between a point & conj normal and the observer
      double precision MArea           ! The area `magnitude' - sin(theta)*d(theta)*d(phi)
      double precision AreaR           ! The radial component of the perturbed surface area vector
      double precision AreaT           ! The theta component of the perturbed surface area vector
      double precision AreaP           ! The phi component of the perturbed surface area vector
      double precision Area            ! The magnitude of the perturbed surface area vector
      double precision NormR           ! The radial component of the perturbed surface area normal
      double precision NormT           ! The theta component of the perturbed surface area normal
      double precision NormP           ! The phi component of the perturbed surface area normal
      double precision AProj           ! The projected area of a grid point
      double precision VProj           ! The projected velocity of a grid point
      double precision Temp            ! The perturbed temperature of a grid point
      double precision Grav            ! The perturbed gravity of a grid point
      double precision Lambda(maxmde)  ! The value of the eigenvalue used in temperature calculations

C Declare the variables used for general control

      logical ok                       ! Status flag for some of the subroutines called
      integer ferr                     ! The iostat variable for use with file errors
      integer fcount                   ! Counter to step through the field calculations
      integer gcount                   ! Counter to step through the partial grid points (ie theta)
      integer pcount                   ! Counter to step through phi at a given theta
      integer Mode                     ! Counter to step through the modes defined
      integer NGPhi		       ! Number of points in phi at a given colatitude
      double precision FTime           ! The time of a field calculations (hours after 0)
      double precision VMax	       ! The maximum velocity amplitude (scalar) found...
      double precision dRMax           ! The maximum radius displacement found...
      double precision dTMax           ! The maximum temperature perturbation found...
      double precision dGMax           ! The maximum gravity perturbation found...
      double precision pVmax	       ! The maximum projected velocity
      double precision pVmin	       ! The minimum projected velocity
      double precision TMax	       ! The maximum temperature
      double precision TMin 	       ! The minimum temperature
      double precision FTMax	       ! The maximum temperature for the whole run of fields
      double precision FTMin           ! The minimum temperature for the whole run of fields
      character*80 string              ! A string variable to hold titles etc...
      character*80 dfname	       ! A string to hold the dump filenames
      character*80 afname              ! A string to hold the aux filenames
      character*80 tfname              ! A string to hold the timings filename
      character*24 getlog	       ! The login name of the user
      character*24 fdate	       ! The date at which the routine is run
      integer getcwd		       ! The get cwd function
      integer ierrno		       ! The error returned by getcwd

C Declare the external, DEF Fortran-specific routines

      external getenv			! The external routine to read an environment variable
      external getlog			! The external function to read the login name
      external getcwd			! The external function to read the current dir
      external fdate

C Print out the introductory banner

      write(chandl,100) Version,Date
 100  format('Bruce Version ',A,' (',A,')')
      
C Call blojob to parse the standard input command file (which has file handle fhandl)

      call blojob(ok)

C Check all was ok...

      if(.not.ok) goto 9000

C Now we can set uo the model grid using bmakeg in much the same way

      call bmakeg(ok)

      if(.not.ok) goto 9000

C Finally, use breprt to print out a bit of diagnostic information

      call breprt

C Loop over the number of modes to find the W-matrix for each
C mode, diagonalise the matrix, and use the LSD library vector
C routines to get the vectors containing the expansion coefficients
C for each mode into the expansion coefficient array space.

C Blank line...

      write(chandl,'('' '')')

      do Mode=1,NModes,1

C First things first, depending on whether the mode has LSDEff .true.
C or .false., set up nu. Then do all of the usual Lee & Saio matrix generation stuff.
C If LSDEff is false, do the vector routines with emat as the identity and 1/dvec as l(l+1)

        if(LSDEff) then

           if(numode(Mode).eq.0.) then
              nu=2.D0*Omega/CFmode(Mode)
           else
              nu=numode(Mode)
           endif

C Do matrix stuff...

C Call the first of the Lee & Saio LSD routines to generate the W-matrix.
C If the generation is sucessful, continue, otherwise write out an error
C message.

          call lsdMakeW(Mmode(Mode),nu,parity(Mode),
     :                MatDim,DimMax,DVec,SVec,ok)

          if(.not.ok) then
            write(ehandl,'(''*** There was a problem generating'',
     :      '' the W-matrix for Mode #'',I2,'' - try adjusting'',
     :      '' the mode period'')') Mode
            goto 9000
          endif

C Use the NR routine tqli to find the eigenvalues and eigenvectors of the Matrix
C stored in DVec,SVec, putting them in DVec and EMat respectively

          call lsdTQLI(DVec,SVec,MatDim,DimMax,EMat)

C Call the lsd routine to get the eigenvalue indexing array. Basically,
C the jth element of EgIndx is where in DVec and EMat(the eigenvector matrix)
C the jth eigenvalue/vector occurs. Since we don't need to use SVec anymore,
C we can supply it to lsdFindE as the workspace required...

          call lsdFindE(Mmode(Mode),nu,MatDim,
     :                DimMax,DVec,SVec,EgIndx,
     :                parity(Mode))

C Now we have to do a little diddle. The eigenvector EMat(1,EqIndx(Jmode)) passed
C to all of the LSD routines is normalised to have a length of 1, but the 'direction'
C in which it is pointing is indeterminate - consider that if x is an eigenvector of M,
C then so is a*x, and if a is chosen so that a*x is a unit vector, the sign of a used
C is still arbitrary. To ensure that similar runs with different nu do not have a phase
C difference of pi (ie 180 degrees out of phase, due to this arbitrary sign), we alter
C the sign of the eigenvector EMat(1,EgIndx(Jmode)) so that the 'principal coefficient'
C is always greater than zero. The principal coefficient is EMat(1,EgIndx(Jmode)),
C which in the zero-rotation limit is 1, all other coefficients being zero. The
C principal coefficient determines how much of the unperturbed mode exists in a given
C perturbed mode.

          if(EMat(Jmode(Mode),EgIndx(Jmode(Mode))).lt.0.D0) then
            do ISign=1,MatDim
              EMat(ISign,EgIndx(Jmode(Mode)))=
     :       -EMat(ISign,EgIndx(Jmode(Mode)))
            enddo
          endif
 
C Now we convert the appropiate eigenvector, eigenvalue etc. into a set of
C vectors used as the expansion coefficients when the NRP functions are
C calculated as sums over associated legendre polynomials. Use of these vectors
C should speed up the routines considerably.

          call lsdVRad(RadVec(1,Mode),Mmode(Mode),MatDim,DimMax,
     :               EMat(1,EgIndx(Jmode(Mode))),
     :               parity(Mode))

          call lsdVHor(HorVec(1,Mode),Mmode(Mode),
     :               1.D0/DVec(EgIndx(Jmode(Mode))),
     :               MatDim,DimMax,
     :               EMat(1,EgIndx(Jmode(Mode))),
     :               parity(Mode))

          call lsdVTor(TorVec(1,Mode),Mmode(Mode),nu,
     :               1.D0/DVec(EgIndx(Jmode(Mode))),
     :               MatDim,DimMax,
     :               EMat(1,EgIndx(Jmode(Mode))),
     :               parity(Mode))

C Set up the lambda eigenvalue
 
          Lambda(Mode)=1.D0/DVec(EgIndx(Jmode(Mode)))

        else

C This is the part for LSDEff false - basically, it is very similar to the stuff above,
C but we nominally take emat to be the unit matrix and 1/dvec to be l(l+1). The routine
C lsdVharm sets up the vectors so that single spherical harmonics are used.

          call lsdVharm(Mmode(mode),Jmode(mode),MatDim,DimMax,
     :      RadVec(1,Mode),HorVec(1,Mode),TorVec(1,Mode),
     :      parity(Mode))

          Lambda(Mode)=LMode(Mode)*(LMode(Mode)+1.D0)

        endif

C Loop back around to do the next mode.

      enddo

C Open up the timings file (if required)

      if(WrtTim) then

        tfname=DmStub(1:index(DmStub,' ')-1)//'.times'

        open(unit=thandl,file=tfname,status='new',err=7500,iostat=ferr)

      endif

C OK, now we have got all we need to proceed with the field calculations.
C What follows is a number of nested loops. The outermost loop loops over
C the different field calculations (this is the loop over time). For each
C field calculation, the time of the calculation is first worked out. This
C time is taken to be in the middle of the `time-slot' allocated to each
C field calculation - for instance, of TStart=0 & TStart=3, a 3-field
C run would do calculations at times 0.5,1.5 and 2.5. Once we have got
C the time, we loop over theta on the stellar surface. Theta only varies from
C 0 to pi/2 (pole-to-equator), since the subsequent code has been written
C to take advantage of the parity about the equator inherent in each mode.
C At each theta, we loop over the modes to get the theta-part of Vr, Vtheta,
C and VPhi into an array, along with a number of other variables (see below)
C We then loop over phi - see below

C Set up FTMax and FTMin initially

      FTMax=-1.D20
      FTMin=1.D20

C Write the heading for the status information

      write(chandl,200) 'Calculation Results'
 200  format(/'%%%'/'% ',A/'%%%'/)

      write(chandl,201)
     : 'Fld#','t-Epoch','|V|_max',
     : 'Vp_max','Vp_min',
     : 'Tm_Max','Tm_Min',
     : '|dR/R|','|dT/T|','|d lg|',
     : 'Filename'
 201  format(1X,A4,1X,2(A7,1X),7(A6,1X),A/)

C Firstly, loop over the fields...

      do fcount=1,NField,1

C Get the time of this field calculation from the Times array

        FTime=Times(fcount)

C Get the title of the filename for this field calculation into dfname,
C and attempt to open up an output file.

        write(dfname,'(A,I3.3)') 
     :   DmStub(1:index(DmStub,' ')-1),fcount

        open(unit=dhandl,file=dfname,status='new',
     :   form='unformatted',err=8000,iostat=ferr)

C Now try to open an auxilary file with the same basic name, if WrtAux is .true.

        if(WrtAux) then
          write(afname,'(A,I3.3,A)')
     :     DmStub(1:index(DmStub,' ')-1),fcount,'.aux'

          open(unit=ahandl,file=afname,status='new',
     :     form='unformatted',err=8500,iostat=ferr)
        endif

C Write the name of the dump file, plus the time, to the timings file if WrtTim is
C .true.

        if(WrtTim) then
          write(thandl,*) dfname(1:index(dfname,' ')-1),FTime/3600.D0
        endif 

C With the output file opened, write out the number of visible grid points and also
C the time of the field calculation

        write(dhandl) GrdVis,real(FTime)

C Do the same for the aux file, writing the number of visible points, the inclination and
C the Polar radius, normalised by REq

        if(WrtAux) then
          write(ahandl) GrdVis,real(DIncl),
     :                  real(RPole/REq)
        endif

C Initialise the minimum / maximum values

        dRMax=-1.D20
        dTMax=-1.D20
        dGMax=-1.D20
        VMax=-1.D20
        pVMax=-1.D20
        pvMin=1.D20
        TMax=-1.D20
        TMin=1.D20

C Loop over each colatitude (theta) on the stellar grid by stepping gcount
C through the partial stellar grid

        do gcount=1,NGrid,1

C Work out theta for this grid point

          theta=(gcount-0.5D0)/dble(NGrid)*D90

C Loop over all of the modes to get the theta-part of Vr, Vtheta and Vphi for
C each mode, and store them in arrays. To do the calculations, we first set up
C ctheta with the value of cos(theta), & stheta with sin(theta). Then, for each
C mode, we first work out RBasis, the radial basis state. Using RBasis, we
C calculate the partial radial velocity field pVRad (which requires a phi part
C to get the real radial velocity) and the fractional radius variation pDRad.
C Note that RBasis is proportional to the fractional radius variation and not
C the absolute radius variation, whereas pVRad is proportional to the absolute
C radius variation, so we must multiply RBasis by Radius in working out pVRad;
C a similar multiplication occurs when we work out the horizontal velocity fields
C (which we do only if HorEff is .true.). Since the amplitude of the modes is
C defined in terms of the velocity amplitude, we must divide by some radius (chosen
C to be the polar radius Rpole) as well as by the angular frequency to get the
C fractional radius amplitude from the velocity amplitude. This normalisation
C is switchable by the ColNrm (colatitude normalize) flag

          ctheta=cos(theta)
          stheta=sin(theta)
          rtheta=1.D0/stheta

          if (ColNrm) then
            cnorm=RGrid(gcount)/Rpole
            dcnorm=dRGrid(gcount)/Rpole
          else
            cnorm=1.D0
            dcnorm=0.D0
          endif

          do Mode=1,NModes,1

C Set up the theta part of the radial basis state in RBasis

            RBasis=RecpPi*
     :        lsdFRad(Mmode(Mode),ctheta,MatDim,DimMax,
     :         RadVec(1,Mode),parity(Mode))

C Use RBasis to get the partial radial velocity pVRad:

            pVRad(Mode)=VAmode(Mode)*RBasis*cnorm*NAmode(Mode)

C Get the horizontal fields - if HAmode is zero, use Kmode for
C the amplitudes of the horizontal fields, otherwise use the
C value of HAmode

            if(HorEff) then

              pVThe(Mode)=RecpPi*VAmode(Mode)*(
     :         lsdFDHor(Mmode(Mode),ctheta,MatDim,DimMax,
     :          HorVec(1,Mode),parity(Mode)) +
     :         lsdFTor(Mmode(Mode),ctheta,MatDim,DimMax,
     :          TorVec(1,Mode),parity(Mode))*Mmode(Mode)*rtheta )*
     :         cnorm*NAmode(Mode)

              pVPhi(Mode)=-RecpPi*VAmode(Mode)*(
     :         lsdFHor(Mmode(Mode),ctheta,MatDim,DimMax,
     :          HorVec(1,Mode),parity(Mode))*Mmode(mode)*rtheta +
     :         lsdFDTor(Mmode(Mode),ctheta,MatDim,DimMax,
     :          TorVec(1,Mode),parity(Mode)) )*
     :          cnorm*NAmode(Mode)

C Do the amplitude scalings

              if(HAmode(Mode).eq.0.) then
                 pVThe(Mode)=pVThe(Mode)*Kmode(Mode)
                 pVPhi(Mode)=pVPhi(Mode)*Kmode(Mode)
              else
                 pVThe(Mode)=pVThe(Mode)*HAmode(Mode)
                 pVPhi(Mode)=pVPhi(Mode)*HAmode(Mode)
              endif

            else
              pVThe(Mode)=0.D0
              pVPhi(Mode)=0.D0
            endif

C If TmpEff is .true., set up the partial fractional temperature change
C in pDTemp. If TAmode is zero, use the Buta & Smith (1979) expression
C for the amplitude of temperature perturbations; otherwise, use the value
C of TAmode

            if(TmpEff) then
               if(TAmode(Mode).eq.0.) then
                  pFTemp(Mode)=(Gamma-1.D0)/Gamma *
     :                 (Kmode(Mode)*Lambda(Mode) -
     :                 4.D0 - 1.D0/Kmode(Mode))*
     :                 VAmode(mode)*NAmode(Mode)*
     :                 RBasis/(CFmode(Mode)*Rpole)
               else
                  pFTemp(Mode)=TAmode(Mode)*
     :                 VAmode(mode)*NAmode(Mode)*
     :                 RBasis/(CFmode(Mode)*Rpole)
               endif
            else
              pFTemp(Mode)=0.D0
            endif

C If PreEff is .true., set up the partial fractional pressure change
C in pFPres If PAmode is zero, use Dziembowski's (1971) expression for 
C the amplitude of pressure perturbations; otherwise, use the value 
C of PAmode.

            if(PreEff) then
               if(PAmode(Mode).eq.0.) then
                  pFPres(Mode)=
     :                 (Kmode(Mode)*Lambda(Mode) -
     :                 4.D0 - 1.D0/Kmode(Mode))*
     :                 VAmode(mode)*NAmode(Mode)*
     :                 RBasis/(CFmode(Mode)*Rpole)
               else
                  pFPres(Mode)=PAmode(Mode)*
     :                 VAmode(mode)*NAmode(Mode)*
     :                 RBasis/(CFmode(Mode)*Rpole)
               endif
            else
              pFPres(Mode)=0.D0
            endif

C If either SrfEff or NrmEff are .true., we are going to have to work out
C the perturbed area element vector later on. To do this, we need the absolute
C radius variation, plus the theta derivative of this, so we set these up in
C pARad and pARad2. As before, since this is an absolute rather than fractional
C quantity, we must multiply RBasis by Radius when we use it. If neither are
C .true., we do not bother setting pARad and pARad2 to be zero, because we
C do another explit check on SrfEff and NrmEff later on. Use dnorm = d/dtheta
C of cnorm

            if(SrfEff.or.NrmEff) then
              pARad(Mode)=VAmode(Mode)*NAmode(Mode)*
     :       RBasis*cnorm/
     :       CFmode(Mode) 
              pARad2(Mode)=dcnorm*VAmode(Mode)*NAmode(Mode)*
     :       RBasis/CFmode(Mode) + 
     :       cnorm*VAmode(Mode)*NAmode(Mode)*RecpPi*
     :       lsdFDRad(Mmode(Mode),ctheta,MatDim,DimMax,
     :        RadVec(1,Mode),parity(Mode))/CFmode(Mode)
            endif

C OK, loop back around to do the next mode...

          enddo

C Now we proceed to loop over phi to do all of the grid points at this colatitude.
C First we work out the number of grid points in the phi-direction at this theta,
C and DelPhi, the range in phi covered by each grid point at this colatitude - this
C is used if we have to use perturbed rather than unperturbed areas. Using this value
C work out MArea=sin(theta)dtheta dphi, which is also used in getting perturbed areas

          NGPhi=int(NEqtr*sin(theta))+1

          DelPhi=D360/NGPhi

          MArea=stheta*DelThe*DelPhi

C Now loop over the phi grid-points. The very first thing that we do is work out the
C vector pointing towards the observer in RTP (ObsR,ObsT,ObsP) at the grid point,
C and at the conjugate grid point (the same point but with theta ->
C pi-theta). Then, to work out whether either of this grid points is visible, we
C take the dot product of these vectors with the corresponding unperturbed surface
C normal vectors to get cosMu and cosMuC. We use the unperturbed surface normals
C rather than the perturbed ones since the only time they will differ in discrminating
C between visible and non-visible points is on points at the limb, which contribute
C very little to the spectra. If neither are visible, we loop back around to get the
C next phi point; otherwise, we we work out the net velocity fields
C (VRad,VThe,VPhi), the net fractional temperature variation (FTemp), the net absolute
C radius variation (ARad), the derivative with respect to theta of ARad (ARad2),
C and furthermore the derivative with respect to phi of ARad (ARad3),
C at the given grid point and at the conjugate point (we do both irrespective of which
C one is visible). We do the grid point and the conjugate point together to optimise on
C calculating trig functions, since they both share the same phi and time dependance.
C Furthermore, when we do the conjugate point, we take advantage of the well-defined
C parity of each mode to work out what the partial velocity fields etc. should be.
C The naming convention used is that a suffix C indicates a conjugate grid point value 
C Once all this is done, we individually test cosMu and CosMuC to see which of
C the point/conjugate point were visible. For visible ones, if either of SrfEff or NrmEff
C are true, we work out the three RTP components of the perturbed area element vector using
C the ARad/ARadC quantities, and convert these into a perturbed surface normal vector and a
C perturbed scalar area. Then, if NrmEff is .true., we modify cosMu/CosMuC; if SrfEff
C is .true., we get the projected perturbed area and bung it into AProj. Otherwise,
C we bung the projected grid (unperturbed) area into AProj. The projected velocity VProj
C is worked out - if GrvNrm is .true., the velocity fields act along/ || to the unperturbed
C surface normals(see below); otherwise, they act along RTP. The temperature of the point
C is worked out using the temperature grid and FTemp. All of these parameters are then
C written out to the output file, and we loop back for the next phi value. Phew!

          do pcount=1,NGPhi,1

C Work out the phi of this point, and trig functions associated with it

            phi=(pcount-0.5D0)/dble(NGPhi)*D360

            cphi=cos(phi)
            sphi=sin(phi)

C Work out the observers vector for the grid point and the vector for the conjugate grid
C point.

            ObsR=cDIncl*ctheta+sDIncl*stheta*cphi
            ObsT=-cDIncl*stheta+SDIncl*ctheta*cphi
            ObsP=-sDIncl*sphi

            ObsRC=-cDIncl*ctheta+sDIncl*stheta*cphi
            ObsTC=-cDIncl*stheta-SDIncl*ctheta*cphi
            ObsPC=-sDIncl*sphi

C Work out cosMu and cosMuC using the unperturbed surface normal vectors to work out the
C visibility of the grid point and its conjugate point. The - sign in the second expression
C is due to the fact that the surface normal grid is calculated only for the northern
C hemisphere, and must be corrected for use in the southern hemisphere, since the theta
C part of the surface normal vector is asymmetric about the equator

            cosMu =NRGrid(gcount)*ObsR+NTGrid(gcount)*ObsT
            cosMuC=NRGrid(gcount)*ObsRC-NTGrid(gcount)*ObsTC

C See if either of the points is visible; if so, get the fields at both points...

            if(cosMu.ge.0.D0.or.cosMuC.gt.0.D0) then

C Set up the net values for the grid point to be zero:

            VRad=0.D0
            VThe=0.D0
            VPhi=0.D0

            FTemp=0.D0
            FPres=0.D0

            ARad =0.D0
            ARad2=0.D0
            ARad3=0.D0

C Set up the net values for the conjugate grid point to be zero

            VRadC=0.D0
            VTheC=0.D0
            VPhiC=0.D0

            FTempC=0.D0
            FPresC=0.D0

            ARadC =0.D0
            ARad2C=0.D0
            ARad3C=0.D0

C Loop over the modes to work out the net values of the quantities above...

            do Mode=1,NModes,1

C Set up the trigonometric functions cosMP and sinMP which are the parts of
C the basis states which depend upon phi; we need both a cosine and a sine since
C there are phase shifts between the basis states due do complex numbers. TsinMP
C is similar to sinMP, but it is phase shifted by TPmode(Mode), which is the temperature
C phase-shift for the mode in question. Likewise, HcosMP and HsinMP are similar
C to cosMP and sinMP, but are phase shifted by HPmode(Mode), which is the horizontal 
C velocity field phase-shift. Finally, PsinMP is shifted by PPmode(Mode), which is
C the pressure phase-shift for the mode in question.

            cosMP=cos(Mmode(Mode)*(phi-Omega*FTime)
     :         +CFmode(Mode)*FTime+IPmode(Mode))

            sinMP=sin(Mmode(Mode)*(phi-Omega*FTime)
     :         +CFmode(Mode)*FTime+IPmode(Mode))

            TsinMP=sin(Mmode(Mode)*(phi-Omega*FTime)
     :         +CFmode(Mode)*FTime+IPmode(Mode)
     :         +TPmode(Mode))

            HcosMP=cos(Mmode(Mode)*(phi-Omega*FTime)
     :         +CFmode(Mode)*FTime+IPmode(Mode)
     :         +HPmode(Mode))

            HsinMP=sin(Mmode(Mode)*(phi-Omega*FTime)
     :         +CFmode(Mode)*FTime+IPmode(Mode)
     :         +HPmode(Mode))

            PsinMP=sin(Mmode(Mode)*(phi-Omega*FTime)
     :         +CFmode(Mode)*FTime+IPmode(Mode)
     :         +PPmode(Mode))

C Update the net values defined above for the grid point

            VRad=VRad+pVRad(Mode)*cosMP
            VThe=VThe+pVThe(Mode)*HcosMP
            VPhi=VPhi+pVPhi(Mode)*HsinMP

            FTemp=FTemp+pFTemp(Mode)*TsinMP
            FPres=FPres+pFPres(Mode)*PsinMP

            ARad =ARad +pARad(Mode) *sinMP
            ARad2=ARad2+pARad2(Mode)*sinMP
            Arad3=ARad3+pARad(Mode)*Mmode(Mode)*cosMP

C ...and, dependant on the parity of the mode, update the net values defined
C above for the conjugate grid point

            if(parity(Mode)) then

            VRadC=VRadC+pVRad(Mode)*cosMP
            VTheC=VTheC-pVThe(Mode)*HcosMP
            VPhiC=VPhiC+pVPhi(Mode)*HsinMP

            FTempC=FTempC+pFTemp(Mode)*TsinMP
            FPresC=FPresC+pFPres(Mode)*PsinMP

            ARadC =ARadC +pARad(Mode) *sinMP
            ARad2C=ARad2C-pARad2(Mode)*sinMP
            Arad3C=ARad3C+pARad(Mode)*Mmode(Mode)*cosMP

            else

            VRadC=VRadC-pVRad(Mode)*cosMP
            VTheC=VTheC+pVThe(Mode)*HcosMP
            VPhiC=VPhiC-pVPhi(Mode)*HsinMP

            FTempC=FTempC-pFTemp(Mode)*TsinMP
            FPresC=FPresC-pFPres(Mode)*PsinMP

            ARadC =ARadC -pARad(Mode) *sinMP
            ARad2C=ARad2C+pARad2(Mode)*sinMP
            Arad3C=ARad3C-pARad(Mode)*Mmode(Mode)*cosMP

            endif

C Loop back around to add in the bits and bobs for the next field.

            enddo

C Now that we have the net fields for the grid point and the conjugate 
C point, see if it was the grid point that was visible - if it was,
C work out the final parameters and write them out

            if(cosMu.ge.0.D0) then

C Now, for the grid point in question, if either SrfEff or NrmEff are
C true, we are going to need the perturbed area element vector. We work
C this out here, and convert it into a scalar perturbed area Area

            if(SrfEff.or.NrmEff) then
              AreaR=MArea*(RGrid(gcount)+ARad)**2
              AreaT=-MArea*(RGrid(gcount)+ARad)*
     :         (dRGrid(gcount)+ARad2)
              AreaP=-MArea*(RGrid(gcount)+ARad)*
     :         ARad3/stheta
              Area=dsqrt(AreaR**2+AreaT**2+AreaP**2)
              NormR=AreaR/Area
              NormT=AreaT/Area
              NormP=AreaP/Area
            endif

C If NrmEff is true, get the perturbed value of cosMu using the new Normal and the
C observer vector, overriding the old value of cosMu

            if(NrmEff) cosMu=NormR*ObsR+
     :                       NormT*ObsT+NormP*ObsP

C If SrfEff is true, put the projected perturbed area into AProj; otherwise,
C bung in the projected unperturbed area

            if(SrfEff) then
              AProj=cosMu*Area
            else
              AProj=cosMu*AGrid(gcount)
            endif 
             
C Work out the projected velocity, taking the velocity fields to act along the
C radial vector if GrvNrm is .false., or along the unperturbed surface normal vector
C if it is .true.; we use the unperturbed surface normal since the perturbed surface
C normals only pertain to the direction the surface element is facing and not the
C direction it is moving in (which is determined by the gravity vector, which
C we do not perturb). Also add in the velocity due to the stellar rotation.
C Note that the velocity convention is that a *positive* projected velocity
C represents a movement *towards* the observer...

            if(GrvFld) then
              VProj=(NRGrid(gcount)*VRad-
     :         NTGrid(gcount)*VThe)*ObsR +
     :              (NTGrid(gcount)*VRad+
     :         NRGrid(gcount)*VThe)*ObsT +
     :        (VPhi+Omega*RGrid(gcount)*stheta)*ObsP
            else
              VProj=VRad*ObsR+VThe*ObsT+
     :        (VPhi+Omega*Rgrid(gcount)*stheta)*ObsP
            endif

C Update VMax, dRMax, dTMax and dGMax

            VMax=max(VMax,dsqrt(VRad**2+VThe**2+VPhi**2))
            dRMax=max(dRMax,abs(ARad/RGrid(gcount)))
            dTMax=max(dTMax,abs(FTemp))
            dGMax=max(dGMax,abs(FPres))

C Work out the perturbed (or not as the case may be) temperature of the grid
C point, and bung it into Temp

            Temp=TGrid(gcount)+TGrid(gcount)*FTemp

C Work out the perturbed gravity of the grid point, and bung it in Grav. This
C expression assumes that the fractional gravity perturbation is proportional
C to the fractional pressure perturbation

            Grav=GGrid(gcount)+GGrid(gcount)*FPres

C OK, we have everything now, so write it to the output stream in TVAGC order

            write(dhandl) 
     :       real(Temp),
     :       real(Vproj),
     :       real(AProj),
     :       real(Grav),
     :       real(cosMu)

C Write out the auxilary information

            if(WrtAux) then
            write(ahandl)
     :       real(theta),
     :       real(phi),
     :       real(RGrid(gcount)/REq),
     :       real(VRad),
     :       real(VProj),
     :       real(Temp)
            endif

C Update pVMax etc

            pVMax=max(pVMax,VProj)
            pVMin=min(pVMin,VProj)
            TMax=max(TMax,Temp)
            TMin=min(TMin,Temp)

C This is the endif for seeing if the grid point was visible.

            endif

C We now check if the conjugate grid point was visible -much the same as above...

            if(cosMuC.ge.0.D0) then

C Now, for the conjugate grid point in question, if either SrfEff or NrmEff are
C true, we are going to need the perturbed area element vector. We work
C this out here, and convert it into a scalar perturbed area Area. Note that
C this expression differs slightly from the one for the (non-conjugate) grid
C point since dRGrid is defined in the northern hemisphere and is asymmetric
C about the equator 

            if(SrfEff.or.NrmEff) then
              AreaR=MArea*(RGrid(gcount)+ARadC)**2
              AreaT=-MArea*(RGrid(gcount)+ARadC)*
     :         (-dRGrid(gcount)+ARad2C)
              AreaP=-MArea*(RGrid(gcount)+ARadC)*
     :         ARad3C/stheta
              Area=dsqrt(AreaR**2+AreaT**2+AreaP**2)
              NormR=AreaR/Area
              NormT=AreaT/Area
              NormP=AreaP/Area
            endif

C If NrmEff is true, get the perturbed value of cosMuC using the new Normal and the conjugate
C observer vector, overriding the old value of cosMuC.

            if(NrmEff) cosMuC=NormR*ObsRC+
     :                        NormT*ObsTC+NormP*ObsPC

C If SrfEff is true, put the projected perturbed area into AProj; otherwise,
C bung in the projected unperturbed area

            if(SrfEff) then
              AProj=cosMuC*Area
            else
              AProj=cosMuC*AGrid(gcount)
            endif 
             
C Work out the projected velocity, taking the velocity fields to act along the
C radial vector if GrvNrm is .false., or along the unperturbed surface normal vector
C if it is .true.; we use the unperturbed surface normal since the perturbed surface
C normals only pertain to the direction the surface element is facing and not the
C direction it is moving in (which is determined by the gravity vector, which
C we do not perturb). Also add in the velocity due to the stellar rotation.
C Note that the velocity convention is that a *positive* projected velocity
C represents a movement *towards* the observer.
C This expression is slightly different from the one
C for the (non-conjugate) grid point due to the fact that NTGrid is defined for
C the northen hemisphere and is asymmetric about the equator.  

            if(GrvFld) then
              VProj=(NRGrid(gcount)*VRadC+
     :         NTGrid(gcount)*VTheC)*ObsRC +
     :              (-NTGrid(gcount)*VRadC+
     :         NRGrid(gcount)*VTheC)*ObsTC +
     :        (VPhiC+Omega*RGrid(gcount)*stheta)*ObsPC
            else
              VProj=VRadC*ObsRC+VTheC*ObsTC+
     :        (VPhiC+Omega*RGrid(gcount)*stheta)*ObsPC
            endif

C Update VMax, dRMax, dTMax and dGMax

            VMax=max(VMax,dsqrt(VRadC**2+VTheC**2+VPhiC**2))
            dRMax=max(dRMax,abs(ARadC/RGrid(gcount)))
            dTMax=max(dTMax,abs(FTempC))
            dGMax=max(dGMax,abs(FPresC))

C Work out the perturbed (or not as the case may be) temperature of the grid
C point, and bung it into Temp

            Temp=TGrid(gcount)+TGrid(gcount)*FTempC

C Work out the perturbed gravity of the grid point, and bung it in Grav. This
C expression assumes that the fractional gravity perturbation is proportional
C to the fractional pressure perturbation

            Grav=GGrid(gcount)+GGrid(gcount)*FPresC

C OK, we have everything now, so write it to the output stream in TVAGC order,
C if cosMuC is greater than zero.

            write(dhandl) 
     :       real(Temp),
     :       real(Vproj),
     :       real(AProj),
     :       real(Grav),
     :       real(cosMuC)

C Write out the auxillary information, remembering to use the co-theta (180-theta)

            if(WrtAux) then
            write(ahandl)
     :       real(D180-theta),
     :       real(phi),
     :       real(RGrid(gcount)/REq),
     :       real(VRadC),
     :       real(VProj),
     :       real(Temp)
            endif

C Update pVMax etc

            pVMax=max(pVMax,VProj)
            pVMin=min(pVMin,VProj)
            TMax=max(TMax,Temp)
            TMin=min(TMin,Temp)

C This is the endif for seeing if the conjugate grid point was visible.

            endif


C This is the endif for whether any grid point was visible...

            endif

C Loop back around to get the next phi grid point

          enddo

C Loop back around to get the next theta grid point

        enddo

C Close the current output file...

        close(dhandl,iostat=ferr,err=8000)

C Close the aux file (if it has been opened)
 
        if(WrtAux) then
          close(ahandl,iostat=ferr,err=8500)
        endif

C Write out a whole load of diagnostic information....

        write(chandl,202) 
     :  fcount,(FTime-Times(1))/3600.D0,
     :  VMax/1.D3,pVMax/1.D3,pVMin/1.D3,
     :  nint(TMax),nint(TMin),
     :  dRMax,dTMax,dGMax/log(10.),
     :  dfname
 202    format(1X,I4,1X,2(F7.2,1X),2(F6.1,1X),2(I6,1X),3(F6.4,1X),A12)

C Update FTMax and FTMin

       FTMax=max(FTMax,TMax)
       FTMin=min(FTMin,TMin)

C Loop back around to do then next field calculation
      
      enddo

C Close the timings file if WrtTim is .true.

      if(WrtTim) then
        close(thandl,iostat=ferr,err=7500)
      endif
     
C Jump to the end of the program to quit out...

      goto 9000

C Error jump-in for failure on the timings file

 7500 continue

      write(chandl,'(''*** An error was encountered whilst'',
     :'' trying to access the file '',A)') tfname
      goto 9000

C Error jump-in for failure on a dump file

 8000 continue

      write(chandl,'(''*** An error was encountered whilst'',
     :'' trying to access the file '',A)') dfname
      goto 9000

C Error jump-in for failure on an aux file
 
 8500 continue

      write(chandl,'(''*** An error was encountered whilst'',
     :'' trying to access the file '',A)') afname
      goto 9000

C End pof program jump-in point

 9000 continue

      end
 

      SUBROUTINE lsdindexx(n,arr,indx)
      INTEGER n,indx(n),M,NSTACK
      DOUBLE PRECISION arr(n)
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      DOUBLE PRECISION a
      do 11 j=1,n
        indx(j)=j
11    continue
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 13 j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do 12 i=j-1,1,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
12        continue
          i=0
2         indx(i+1)=indxt
13      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(l)))then
          itemp=indx(l+1)
          indx(l+1)=indx(l)
          indx(l)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END
C  (C) Copr. 1986-92 Numerical Recipes Software )$(.

      function lsdJml(m,l)

C*********************************************************************
C
C This is Lee & Saio's function Jml, which is defined in their MNRAS
C (1987) 221, 513-526 paper, and many other of their papers. It is
C a function of two integeral variables m and l.
C
C (c) Richard Townsend 1995 
C
C*********************************************************************

      implicit none	! Turn off implicit typing

C Declare the passed variables

      double precision lsdJml
      integer m     	! The value of m to calculate Jml for
      integer l		! The value of l to calculate Jml for

C Set up the value of Jml...

      if (l.gt.abs(m)) then
        lsdJml=dsqrt((l**2-m**2)/(4.D0*l**2-1.D0))
      else
        lsdJml=0.D0
      endif

C Return...

      return

      end

      subroutine lsdfindE(m,nu,matdim,dimmax,
     :                 eigval,tmpind,egindx,parity)

C**************************************************************
C
C This subroutine is passed a vector containing the reciprocal eigenvalues
C of Lee & Saio's W-Matrix (MNRAS (1987) 221). The vector is
C of physical dimension dimmax and of logical length matdim, so the W-Matrix
C is implied to be matdim*matdim in logical dimension. Given these eigenvalues, and
C the values of the azimuthal quantum number m & the rotation 
C parameter nu, an index list is constructed whose j'th element corresponds
C to the position in eigval which the j'th eigenvalue appears at.
C By j'th eigenvalue, I mean the eigenvalue which approaches lj(lj+1)
C in the zero-rotation(nu=0) limit, where lj=|m|+2(j-1) for even modes
C and lj=|m|+1+2(j-1) for odd modes. The subroutine needs to know
C the parity of the modes it is dealing with - these are passed in
C the variable parity, with parity=.true. for even modes, and parity=
C .false. for odd modes.
C
C Started:23/3/95
C Updated:27/3/95
C
C (c) Richard Townsend 1995
C
C*********************************************************************

      implicit none		! Turn off implicit typing

C Declare the passed variables

      integer m		   		! The m value of the modes
      double precision nu  		! The rotation parameter
      integer matdim	    		! The number of eigenvalues to sort
      integer dimmax	   		! The physical dimension of eigval, tmpind and eigval
      double precision eigval(dimmax)	! The vector containing the eigenvalues
      integer tmpind(dimmax)		! Temporary indexing array for sorting...
      integer egindx(dimmax) 		! The index list
      logical parity	     		! The parity of the set of modes in question

C Declare the in-program variables

      integer i		 		! Looping variable...
      integer j		       		! Looping variable...
      integer lj	       		! lj value for finding nosing...
      integer temp	       		! Temporary variable for permuting...
      integer nosing	       		! The number of matrix singularities between
			       		! rotation parmeter=nu and rotation parameter=0

C The sorting basically works in the following way: At nu=0, the seqence
C of the reciprocal eigenvalues is that the smallest lj eigenvalue is the
C most positive, the largest lj eigenvalue is the most negative (although
C both are greater than zero), and the eigenvalues are sequenced regularly
C between these two limits. As nu is moved away from zero, every time the 
C matrix passes through a singularity, this ordering is permuted cyclicaly once


C First we work out how many singularities we have crossed since 
C nu was at zero. First see if m*nu is greater than zero, if not 
C nosing must be zero.

      if(m*nu.lt.0.D0) then
        nosing=0
      else

C Now we loop through all the j values, counting the number of dooh-dads which have
C gone singular...

        nosing=0

        do j=1,matdim

          if(parity) then
            lj=abs(m)+2*(j-1)
          else
            lj=abs(m)+1+2*(j-1)
          endif

        if (m*nu.gt.(lj+1)*(lj+2)) nosing=nosing+1

        enddo

      endif

C Singularities occur also for l(l-1)=m*nu, but this just duplicates the ones
C above. However, for odd modes, the method above does not include the l=|m|+1
C singularity of l(l-1)=m*nu, so we have to explicitly count it. We do
C not do this for even modes because this particular singluarity occurs with
C a zero value of Jml and so doesn't matter....

      if(.not.parity.and.m*nu.gt.abs(m)*(abs(m)+1))
     : nosing=nosing+1

C Now call the numerical recipies indexing routine, so that the j'th
C element of tmpind is the index into eigval of the j'th most negative eigenvalue.
C For instance, egindx(5)=4 means that eigval(4) is the 5th most negative eigenvalue.

      call lsdindexx(matdim,eigval,tmpind)

C Now we invert the elements of tmpind (ie reverse the order) to get the
C positive-to-negative indexing rather than the negative-to-positive indexing

      do j=1,matdim
        egindx(j)=tmpind(matdim+1-j)
      enddo

C Now, since at nu=0, the most positive eigenvalue is the j=1 one, the next-most-
C positive is j=2, and this ordering is premuted cyclicaly nosing times, at
C nu=nu, all we have to do to now get the correct values (as mentioned at the
C top of this prog) into eigindx is permute egindx to the left
C nosing times to get what the indexing array would be like at nu=0, and then the j'th
C element of egindx array will be the index of the jth eigenvalue. We permute to the
C left becuase, if for instance nosing was 1, then the eigenvalue index array would
C hold the j=matdim eigenvalue index in the first element, the j=1 index in the 2nd
C element, the j=2 in the third, and so on, so permuting to the left gives the j=1
C index in the first element, the j=2 index in the second etc.

      do j=1,nosing
        temp=egindx(1)
        do i=2,matdim
          egindx(i-1)=egindx(i)
        enddo
        egindx(matdim)=temp
      enddo

C That's all folks....

      return

      end  

      function lsdfdrad(m,ctheta,n,np,
     :                  vrad,parity)

C***************************************************
C
C This function returns the derivative wrt theta of
C the radial velocity function lsdfrad
C of Lee & Saio's Lambda basis (ApJ 1990)
C This routine calculates the derivative of the eigenstate
C for an azimuthal quantum number m and a corresponding
C set of expansion coefficients vrad(1:n) which has physical dimension np.
C These coeffs are previously calculated using lsdvrad.
C parity defines whether this is done for odd or even modes.
C
C This function now adheres to the Condon & Shortley phase convention
C
C Stated:30/3/95
C Last Modified:
C
C   29/11/00 - Fixed problems calculating m=0 and j>1 modes
C
C
C (c) Richard Townsend 1995,2000
C
C*****************************************************

      implicit none		! Turn off implicit typing

C Declare the passed variables

      double precision lsdfdrad	! The returned function
      double precision ctheta	! The cos(theta) value to use
      integer m			! The m-value to use
      integer n			! The number of terms to sum over
      integer np		! The total size of vhor
      double precision vrad(np)	! The column vector containg the coefficients
      logical parity		! The parity to be used - .true.=even

C Declare the in-program variables

      integer j			! The summation counter
      integer lj    		! Holds l-values for Pml's
      integer lj1		! Holds l-values for Pml1's
      integer am		! The absoulte value of m
      integer am1		! am+1
      integer CSPhas		! The Condon & Shortley phase adjustor
      integer CSPha2		! A second phase adjustor
      double precision Pml	! The value of the Assoc. Leg. Poly, l=lj
      double precision Pml1	! The value of the Assoc. Leg. Poly, l=lj+1
      double precision Pm1l	! The value of the Pml for m=m+1
      double precision Pm1l1    ! The value of the Pml1 for m=m+1
      double precision stheta	! Sine of theta
      double precision rtheta   ! value of 1/sin(theta) ; =1.D0 if theta=0
      double precision oddfac	! The product of all odd integers lt (2m-1)

C Set up am=|m| and am1
                             
      am=iabs(m)      
      am1=am+1

C Set up CSPhas & CSPha2

      CSPhas=(-1)**((am-m)/2)
      CSPha2=-sign(1,m)
                       	
C Initialise the staring values of Pml,Pm1l, Pml1 and Pm1l1.
C oddfac has to be used along the way for Pml,Pm1l - see
C Numerical Recipies 2nd Ed p247

      stheta=dsqrt((1.D0-ctheta)*(1.D0+ctheta))
      oddfac=1.D0

      Pml=1.D0

      if (am.gt.0) then
        do j=1,am
          Pml=-Pml*oddfac*stheta
          oddfac=oddfac+2.D0
        enddo

      endif

C Fix the phase of Pml to that of Condon & Shortley

      Pml=Pml*CSPhas

C Get Pm1l1 from Pml. Note that Pm1l1's initial l value is l=m+1 and not l=m,
C and that there is another phase-shift here

      Pm1l1=CSPha2*Pml*oddfac*stheta

C Set up Pml1 and Pm1l

      Pml1=ctheta*(2*am+1)*Pml
      Pm1l=0.D0

C Set up rtheta

      if(stheta.eq.0.D0) then
       rtheta=1.D0
      else
       rtheta=1/stheta
      endif

C First initialise the total sum, including the extra
C eigval and 1/(lj(lj+1)) bits.

      if(parity) then
        lsdfdrad=vrad(1)*am*Pml*rtheta*ctheta
      else
        lsdfdrad=vrad(1)*(am*Pml1*rtheta*ctheta-CSPha2*Pm1l1)
      endif

C And now loop over j to get the rest of the sum...

      do j=2,n

C Update Pml & Pm1l - first get the l-values for these updates,
C and then bung the new values into Pml & Pm1l 

        lj=am+2*(j-1)

        Pml=(ctheta*(2*lj-1)*Pml1
     :      -(lj+am-1)*Pml)/(lj-am)
        Pm1l=(ctheta*(2*lj-1)*Pm1l1
     :      -(lj+am1-1)*Pm1l)/(lj-am1)

C Now update the values of Pml1 & Pm1l1 , again doing lj's
 
        lj1=am+1+2*(j-1)

        Pml1=(ctheta*(2*lj1-1)*Pml
     :       -(lj1+am-1)*Pml1)/(lj1-am)
        Pm1l1=(ctheta*(2*lj1-1)*Pm1l
     :       -(lj1+am1-1)*Pm1l1)/(lj1-am1)

C Now we add in the appropiate term to the sum, depending
C on the parity...

        if(parity) then
          lsdfdrad=lsdfdrad+vrad(j)*
     :     (am*Pml*rtheta*ctheta-CSPha2*Pm1l)
        else
          lsdfdrad=lsdfdrad+vrad(j)*
     :     (am*Pml1*rtheta*ctheta-CSPha2*Pm1l1)
        endif

C Its as simple as that - now loop back around....

      enddo

C Thats all folks - return...

      return

      end

      subroutine blojob(ok)

C*************************************************
C
C This rather long subroutine reads lines from a
C file (or stdin) with file handle fhandl, and
C parses them, setting up all the pulsational
C and stellar parameters which bruce needs to
C perform its calculations. Any error conditions
C result in a report written out to file handle
C chandl; when blojob returns, ok is set up to
C be .true. for an ok exit, or .false. for an
C error condition. Most of the variables used
C are declared in common block include files -
C these files contain all the documentation regarding
C what the variables are.
C
C PS blojob = Bruce LOad JOB parameters, ok?
C
C Started :19/9/95
C Modified:25/9/95
C          4/12/95: To allow the user to define off-axis modes
C          7/12/95: To make aux writing switchable, and to neaten
C                   up the command naming
C          15/4/96: To allow users to specify PHYSICAL_AMPLITUDES
C                   in the fields command; this means that the
C                   actual amplitudes on the surface of the star
C                   should be the same as (or very close to) the
C                   amplitudes specified by the user.
C          26/2/97: Renamed LEE&SAIO: to MATRIX_DIMENSION:
C
C          12/8/97: Fixed a problem with the SMread flag, and corrected
C                   the string length specification of a POLAR_MKS_GRAVITY
C                   command. Also, sorted the STELLAR_MASS so that it
C                   is given by solar masses and not by kg's (which was
C                   of course wrong)
C
C          23/12/98:Added INCLUDE_ENDPOINTS switch to allow for different time 
C                   sampling. This uses the IncEnd variable
C
C          23/12/98:Added WRITE_TIMINGS_FILE switch to allow the writing of timings
C                   to a text file
C
C          1/25/99 :Added READ_TIMINGS_FILE parameter to allow times to be read in
C                   from a file. This involves modifying the way times are stored;
C                   rather than using a start and end time, times are now stored
C                   in an array. This array is established depending on whether
C                   READ_TIMINGS_FILE is used, or whether START_TIME etc is used.
C
C          14/6/99 :Added HORIZONTAL_PHASE_SHIFT parameter to allow phase shifts 
C                   in the horizontal velocity fields to be modelled (this is 
C                   primarily for simulations of wave leakage)
C
C          14/6/99 :Modified so that the maximum number of parameters is now
C                   stored in the parameter maxpar (set at 20).
C
C          22/6/00 :Changed NA_AMPLITUDE_SHIFT and NA_PHASE shift to TEMPERATURE_AMPLITUDE
C                   and TEMPERATURE_PHASE, respectively, to accompany the new variables
C                   TAmode and TPmode
C
C          22/6/00 :Removed the K_VALUE_OVERRIDE parameter, and replaced it with 
C                   HORIZONTAL_VELOCITY_AMPLITUDE, which sets HAmode
C
C          22/6/00 :Renamed the HORIZONTAL_PHASE_SHIFT to HORIZONTAL_VELOCITY_PHASE
C
C          25/6/00 :Replaced PERIOD_FROM_NU with NU
C
C          26/6/00 :Fixed the physical amplitudes scaling
C
C          20/8/00 :Added in code to support the new PRESSURE_EFFECTS, PRESSURE_AMPLITUDE
C                   and PRESSURE_PHASE parameters
C
C (c) Richard Townsend 1995,1996,1997,1998,1999,2000
C***************************************************** 

C Turn of implicit typing

      implicit none

C Define the hard-wired parameters

      include "bruce.compar_define.inc"

C Load in the Stellar parameters common block

      include "bruce.stepar_common.inc"

C Load in the Mode definition common block

      include "bruce.moddef_common.inc"

C Load in the File names common block

      include "bruce.filnam_common.inc"

C Load in the Field definition common block

      include "bruce.flddef_common.inc"

C Load in the Field switches common block

      include "bruce.fldswi_common.inc"

C Declare the parameters

      integer maxpar
      parameter(maxpar=40)      ! Maximum number of parameters in a command

      integer parlen          
      parameter(parlen=255)     ! Maximum parameter length

C Declare the passed variables

      logical ok		! The exit status of the subroutine

C Declare the in-program variables

      character*(parlen) commnd         ! Character string to hold commands read
      character*(parlen) params(maxpar) ! Array to hold the parameters read
      
      integer stat                ! Returned status value from lparse
      integer nline               ! Current line being parsed in input file
      integer parcnt		  ! A counter used to read the parameters in
      integer mcount              ! A counter to step through modes when setting them up
      integer fcount              ! A counter to step through fields when setting up times
  
      double precision period	  ! Holds the corotating/observers period for an individual mode
      double precision discrm	  ! Used to work out the parity of a mode
      double precision rapmatx    ! The function which returns the roAp rotation group matrix element
      double precision bgetmax 	  ! The function which returns the maximum NRP amplitude
      double precision TStart     ! The start time of field calculations
      double precision TEnd       ! The end time of field calculations
      double precision Time       ! Time value read in from the input timings file

      double precision nutemp     ! Temporary value of nu for doing amplitude scalings
      double precision HAtemp     ! Temporary value of HA for doing amplitude scalings

      integer modper		  ! The mode number to get the timings from
      integer roApM(maxmde)	  ! The roAp mode m-value to use for each mode, if required
      logical IncEnd              ! The end-points inclusion flag

C Declare the in-program control flags

      logical timcom              ! Flag for whether a #Timings command was found
      logical fiecom              ! Flag for whether a #Fields command was found
      logical stecom		  ! Flag for whether a #Stellar command was found
  
      logical Lread            	  ! The flag for when L is read
      logical Mread            	  ! The flag for when M is read
      logical VAread		  ! The flag for when the amplitude is read
      logical pread		  ! The flag for when either type of period is read
      logical TAread		  ! The flag for when the temperature amplitude is read
      logical TPread		  ! The flag for when the temperature phase is read
      logical PAread		  ! The flag for when the pressure amplitude is read
      logical PPread		  ! The flag for when the pressure phase is read
      logical IPread		  ! The flag for when the initial phase is read
      logical HAread              ! The flag for when the horizontal velocity field amplitude is read
      logical HPread              ! The flag for when the horizontal velocity field phase is read
      logical BTread   		  ! The flag for when the start-time is read
      logical ETread		  ! The flag for when the end-time is read
      logical NFread		  ! The flag for when the number of fields is read
      logical SRread		  ! The flag for when the polar radius is read
      logical STread		  ! The flag for when the stellar temp. is read
      logical SGread		  ! The flag for when the stellar gravity is read
      logical SMread		  ! The flag for when the stellar mass is read
      logical SVread		  ! The flag for when VEq is read
      logical DIread		  ! The flag for when the stellar inclination is read
      logical Dmread		  ! The flag for when the dump filestub is read
      logical VBread		  ! The flag for when Von Zeipel Beta is read
      logical RTread              ! The flag for when the input timings filename flag is read
      logical nuread              ! The flag for when nu is read
  
      logical PhyAmp		  ! The flag to use physical rather than mathematical amplitudes
   
      logical ppend(maxmde)       ! The pending flag for using an observers period for a given mode
      logical Apend(maxmde)	  ! The pending flag for specifying roApM to get the roAp amplitude
      logical MPpend		  ! The pending flag for getting the timings from a mode period

C Include the constants file and the stellar file

      include 'constants.inc'
      include 'angles.inc'

C Initialise any variables which need to be done before reading
C the parameters

      ok=.false.

      nmodes=0
      timcom=.false.
      fiecom=.false.
      stecom=.false.

C 
      RTread=.false.                    ! The flag for when the input timings filename is read

      write(chandl,'('' Parsing file....'')')

C Now we read lines from the file, using lparse, which parses the
C the input file and gets command/parameter pairs. parser returns
C a value in stat which remarks on the success of the read.

C First initialise nline to be 0...

      nline=0

 1000 continue

C Set up stat to be equal to the dimension of params

      stat=maxpar 

      call parser(fhandl,chandl,commnd,params,stat,nline)

C Now, if stat is greater than zero, interpret the command
C in a huge if_then loop. Note that indenting is not used here.

      if(stat.gt.0) then

C************************************************************************

C Deal with the MODE command, incrementing NModes each time it is read

      if(commnd.eq.'MODE') then

      NModes=NModes+1

C Heck that we have not exceeded maxmde...

      if(NModes.gt.maxmde) then
        write(chandl,
     :  '(''*** There were too many mode commands (maximum '',
     :  I2,'') - Please request a recompile'')') maxmde
        goto 9000
      endif

C Set up the default values

      TAmode(NModes)=0.D0
      TPmode(NModes)=0.D0
      PAmode(NModes)=0.D0
      PPmode(NModes)=0.D0
      IPmode(NModes)=0.D0
      HAmode(NModes)=0.D0
      HPmode(NModes)=0.D0
      numode(NModes)=0.D0

C Set up all of the flags for the parameters which have to be found, and also flags for ones
C which dont have to be found, but must not be duplicated...

      Lread=.false.               	! The flag for when L is read
      Mread=.false.                  	! The flag for when M is read
      VAread=.false.                    ! The flag for when the amplitude is read
      pread=.false.                     ! The flag for when either type of period is read
      TAread=.false.			! The flag for when TA is read
      TPread=.false.			! The flag for when TP is read
      PAread=.false.			! The flag for when PA is read
      PPread=.false.			! The flag for when PP is read
      HAread=.false.                    ! The flag for when HA is read
      HPread=.false.                    ! The flag for when HP is read
      IPread=.false.			! The flag for when the initial phase is read
      nuread=.false.                    ! The flag for when nu is read

C Set up the flags marking pending variables. Apend is used to flag when there is a pending roAp normalising
C amplitude to be read in once the axis offset angle has been read, and ppend indicates that the co-rotating
C period is pending.

      ppend(NModes)=.false.
      Apend(NModes)=.false.

C Interpret the parameters by looping up to stat. I have now put in checks to see if a parameter has
C already been read - if it has, we goto 6500

      do parcnt=1,stat,1

      if(params(parcnt)(1:8).eq.
     :  'L_VALUE:') then
        if(Lread) goto 6500
        read(params(parcnt)(9:),'(I5)',err=8500) Lmode(NModes)
        Lread=.true.
      elseif(params(parcnt)(1:8).eq.
     :  'M_VALUE:') then
        if(Mread) goto 6500
        read(params(parcnt)(9:),'(I5)',err=8500) Mmode(NModes)
        Mread=.true.
      elseif(params(parcnt)(1:19).eq.
     :  'VELOCITY_AMPLITUDE:') then
        if(VAread) goto 6500
        read(params(parcnt)(20:),'(F20.0)',err=8500) VAmode(NModes)
        VAread=.true.
        VAmode(NModes)=VAMode(NModes)*1000.D0
      elseif(params(parcnt)(1:13).eq.
     :  'ROAP_M_VALUE:') then
        if(Apend(NModes)) goto 6500
        read(params(parcnt)(14:),'(I5)',err=8500) roApM(NModes)
        Apend(NModes)=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'COROTATING_PERIOD:') then
        if(pread) goto 6500
        read(params(parcnt)(19:),'(F20.0)',err=8500) period
        pread=.true.
        period=period*3600.D0
      elseif(params(parcnt)(1:17).eq.
     :  'OBSERVERS_PERIOD:') then
        if(pread) goto 6500
        read(params(parcnt)(18:),'(F20.0)',err=8500) period
        pread=.true.
        ppend(NModes)=.true.
        period=period*3600.D0
      elseif(params(parcnt)(1:3).eq.
     :  'NU:') then
        if(nuread) goto 6500
        read(params(parcnt)(4:),'(F20.0)',err=8500) numode(NModes)
        nuread=.true.
      elseif(params(parcnt)(1:22).eq.
     :  'TEMPERATURE_AMPLITUDE:') then
        if(TAread) goto 6500
        read(params(parcnt)(23:),'(F20.0)',err=8500) TAmode(NModes)
        TAread=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'TEMPERATURE_PHASE:') then
        if(TPread) goto 6500
        read(params(parcnt)(19:),'(F20.0)',err=8500) TPmode(NModes)
        TPmode(NModes)=D360*TPmode(NModes)/360.D0
        TPread=.true.
      elseif(params(parcnt)(1:19).eq.
     :  'PRESSURE_AMPLITUDE:') then
        if(PAread) goto 6500
        read(params(parcnt)(20:),'(F20.0)',err=8500) PAmode(NModes)
        PAread=.true.
      elseif(params(parcnt)(1:15).eq.
     :  'PRESSURE_PHASE:') then
        if(PPread) goto 6500
        read(params(parcnt)(16:),'(F20.0)',err=8500) PPmode(NModes)
        PPmode(NModes)=D360*PPmode(NModes)/360.D0
        PPread=.true.
      elseif(params(parcnt)(1:30).eq.
     :  'HORIZONTAL_VELOCITY_AMPLITUDE:') then
        if(HAread) goto 6500
        read(params(parcnt)(31:),'(F20.0)',err=8500) HAmode(NModes)
        HAread=.true.
      elseif(params(parcnt)(1:26).eq.
     :  'HORIZONTAL_VELOCITY_PHASE:') then
        if(HPread) goto 6500
        read(params(parcnt)(27:),'(F20.0)',err=8500) HPmode(NModes)
        HPmode(NModes)=D360*HPmode(NModes)/360.D0
        HPread=.true.
      elseif(params(parcnt)(1:14).eq.
     :  'INITIAL_PHASE:') then
        if(IPread) goto 6500
        read(params(parcnt)(15:),'(F20.0)',err=8500) IPmode(NModes)
        IPmode(NModes)=IPmode(NModes)*D360/360.D0
        IPread=.true.
      else
        goto 7500
      endif

      enddo

C OK, now check we have all of the parameters...

      if(.not.Lread) then
        write(chandl,
     :  '(''*** L_Value was not defined in #Mode #'',I3)') NModes
        goto 9000
      elseif(.not.Mread) then
        write(chandl,
     :  '(''*** M_Value was not defined in #Mode #'',I3)') NModes
        goto 9000
      elseif(.not.VAread) then
        write(chandl,
     :  '(''*** Velocity_Amplitude was not defined in #Mode #'',
     :  I3)') NModes
        goto 9000  
      elseif(.not.pread) then
        write(chandl,
     :  '(''*** Corotating_Period/Observers_Period was not '',
     :  ''defined in #Mode #'',I3)') NModes
        goto 9000
      endif

C Using Lmode and Mmode, get the j-value Jmode and the parity
C First work out a discriminant of the parity...

      discrm=(Lmode(NModes)-iabs(Mmode(NModes)))/2.D0

C Then set up the parity and j

      if(discrm.eq.int(discrm)) then
        Jmode(NModes)=int(discrm+1)
        parity(NModes)=.true.
      else
        JMode(NModes)=int(discrm+0.5)
        parity(NModes)=.false.
      endif

C Convert the period into an angular frequency, checking if the period
C is zero, if the period was set

      if(period.eq.0.D0) then
        write(chandl,
     :  '(''*** A period value of 0 was found in #Mode #'',I3)') NModes
        goto 9000
      else
        CFmode(NModes)=D360/(period)
      endif

C Check that L has an OK value

      if(Lmode(NModes).lt.0) then
        write(chandl,
     :  '(''*** L_Value was less than 0 in #Mode #'',I3)') NModes
        goto 9000
      endif

C Check that M has an OK value

      if(abs(Mmode(NModes)).gt.Lmode(NModes)) then
        write(chandl,
     :  '(''*** |M_Value| exceeded L_Value in #Mode #'',I3)') NModes
        goto 9000
      endif

C Check that, if it was set, roApM has an ok value

      if(abs(roApM(NModes)).gt.Lmode(NModes)
     :   .and.Apend(NModes)) then
        write(chandl,
     :  '(''*** |roAp_M_Value| exceeded L_Value '',
     :  ''in #Mode #'',I3)') NModes
        goto 9000
      endif

C All the other checks are done at the end of the parsing, since we
C set up the pending CFmode and KMode variables there...

C**************************************************************************

C OK, now deal with the timings command

      elseif(commnd.eq.'TIMINGS') then

C Check that this is the only timings command - if not, bum out

      if(timcom) then
        write(chandl,
     :  '(''*** A spurious #Timings command was found at line '',
     :  I2)') nline
        goto 9000
      else
        timcom=.true.
      endif

C Set up all of the flags for the parameters which have to be used

      BTread=.false.           		! The flag for when the start-time is read
      ETread=.false.                    ! The flag for when the end-time is read

C Set up the default parameters

      IncEnd=.false.                    ! The end-points inclusion switch  
      WrtTim=.false.                    ! The write timings file switch
      TmFile= ' '                       ! The input times filename

C Set up the flags for the pending variables

      MPpend=.false.                    ! The pending flag for getting the timings from a mode period

C Interpret all of the parameters

      do parcnt=1,stat,1

      if(params(parcnt)(1:16).eq.
     :  'USE_MODE_PERIOD:') then
        if(BTread.or.ETread) goto 6500
        read(params(parcnt)(17:),'(I5)',err=8500) modper
        BTread=.true.
        ETread=.true.
        MPpend=.true.
      elseif(params(parcnt)(1:11).eq.
     :  'START_TIME:') then
        if(BTread) goto 6500
        read(params(parcnt)(12:),'(F20.0)',err=8500) TStart
        BTread=.true.
      elseif(params(parcnt)(1:12).eq.
     :  'FINISH_TIME:') then
        if(ETread) goto 6500
        read(params(parcnt)(13:),'(F20.0)',err=8500) TEnd
        ETread=.true.
      elseif(params(parcnt)(1:17).eq.
     :  'INCLUDE_ENDPOINTS') then
        if(IncEnd) goto 6500
        IncEnd=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'WRITE_TIMINGS_FILE') then
        if(WrtTim) goto 6500
        WrtTim=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'READ_TIMINGS_FILE:') then
        if(RTread.or.BTread.or.ETread.or.NFRead.or.MPpend) goto 6500
        read(params(parcnt)(19:),'(A)') TmFile
        RTread=.true.
        BTread=.true.
        ETread=.true.
      else
        goto 7500
      endif

      enddo

C Check we have all of the parameters...

      if(.not.BTread) then
        write(chandl,
     :  '(''*** Start_Time/Use_Mode_Period was not defined
     : in #Spectra command'')')
        goto 9000
      elseif(.not.ETread) then
        write(chandl,
     :  '(''*** Finish_Time/Use_Mode_Period was not defined
     : in #Spectra command'')')
        goto 9000
      endif

C Check that the start time preceeds the finish time (if the use_mode_period
C pending flag is not set)

      if(Tstart.ge.Tend.and..not.MPpend.and..not.RTread) then
        write(chandl,
     :  '(''*** Start_Time is greater than or equal to
     : Finish_Time in #Timings command'')')
        goto 9000
      endif

C We set up the timings for the use_mode_period command at the
C end of this subroutine.


C**************************************************************************

C OK, now deal with the fields commands...

      elseif(commnd.eq.'FIELDS') then
     
C Check that this is the only fields command - if not, bum out

      if(fiecom) then
        write(chandl,
     :  '(''*** A spurious #Fields command was found at line '',
     :  I2)') nline
        goto 9000
      else
        fiecom=.true.
      endif
 
C Set up the default parameters

      LSDEff=.false.
      roAEff=.false.
      NrmEff=.false.
      SrfEff=.false.
      GrvFld=.false.
      TmpEff=.false.
      PreEff=.false.
      HorEff=.false.
      ColNrm=.false.
      WrtAux=.false.
      MatDim=DimMax
      RAxOff=0.D0

      PhyAmp=.false.
           
C Set up all of the flags for the parameters which must be found to be false/ which have to be read once...

      NFread=.false.			! The flag for when the number of fields is read
      DmRead=.false.			! The dump fields flag

C Interpret all of the parameters

      do parcnt=1,stat,1

      if(params(parcnt)(1:17).eq.
     :  'NUMBER_OF_FIELDS:') then
        if(NFread.or.RTread) goto 6500
        read(params(parcnt)(18:),'(I5)',err=8500) NField
        NFread=.true.
      elseif(params(parcnt)(1:17).eq.
     :  'MATRIX_DIMENSION:') then
        if(LSDEff) goto 6500
        read(params(parcnt)(18:),'(I5)',err=8500) MatDim
        LSDEff=.true.      
      elseif(params(parcnt)(1:5).eq.
     :  'ROAP:') then
        if(roAEff) goto 6500
        read(params(parcnt)(6:),'(F20.0)',err=8500) RAxOff
        RAxOff=RAxOff*D360/360.D0
        roAEff=.true.
      elseif(params(parcnt).eq.
     :  'NORMAL_FIELDS') then
        if(GrvFld) goto 6500
        GrvFld=.true.
      elseif(params(parcnt).eq.
     :  'AREA_EFFECTS') then
        if(SrfEff) goto 6500
        SrfEff=.true.
      elseif(params(parcnt).eq.
     :  'NORMAL_EFFECTS') then
        if(NrmEff) goto 6500
        NrmEff=.true.
      elseif(params(parcnt)(1:19).eq.
     :  'TEMPERATURE_EFFECTS') then
        if(TmpEff) goto 6500
        TmpEff=.true.
      elseif(params(parcnt)(1:16).eq.
     :  'PRESSURE_EFFECTS') then
        if(PreEff) goto 6500
        PreEff=.true.
      elseif(params(parcnt)(1:26).eq.
     :  'HORIZONTAL_VELOCITY_FIELDS') then
        if(HorEff) goto 6500
        HorEff=.true.
      elseif(params(parcnt)(1:24).eq.
     :  'COLATITUDE_NORMALISATION') then
        if(ColNrm) goto 6500
        ColNrm=.true.
      elseif(params(parcnt)(1:19).eq.
     :  'PHYSICAL_AMPLITUDES') then
        if(PhyAmp) goto 6500
        PhyAmp=.true.
      elseif(params(parcnt)(1:15).eq.
     :  'WRITE_AUX_FILES') then
        if(WrtAux) goto 6500
        WrtAux=.true.
      elseif(params(parcnt)(1:14).eq.
     :  'DUMP_FILESTUB:') then
        if(DmRead) goto 6500
        read(params(parcnt)(15:),'(A)') DmStub
        DmRead=.true.
      else
        goto 7500
      endif

      enddo

C Check we have all of the parameters (NField is checked right
C at the end...)

      if(.not.Dmread) then
        write(chandl,
     :  '(''*** Dump_Filestub was not defined in'',
     :  '' #Fields command'')')
        goto 9000
      endif
          
C Check that Lee & Saio and roAp have not been used together

      if(roAEff.and.LSDEff) then
        write(chandl,
     :  '(''*** roAp and Lee&Saio may not be used together'')')
        goto 9000
      endif

C Check that the Lee & Saio matrix dimension was reasonable...

      if(MatDim.lt.1.and.LSDEff) then
        write(chandl,
     :  '(''*** Lee&Saio was less than 1
     : in #Fields command'')')
        goto 9000
      elseif(MatDim.gt.dimmax) then
        write(chandl,
     :  '(''*** Lee&Saio was too large (maximum '',
     :  I2,'') in #Fields command - Please '',
     :  ''request a recompile'')') dimmax
        goto 9000
      endif

C**************************************************************************

C OK now deal with the Stellar command...

      elseif(commnd.eq.'STELLAR') then
       
C Check that this is the only stellar command - if not, bum out...

      if(stecom) then
        write(chandl,
     :  '(''*** A spurious #Stellar command was found at line '',
     :  I2)') nline
        goto 9000
      else
        stecom=.true.
      endif

C Set up the default parameters

      DIncl=D90

C Set up the flags for the parameters which have to be set up, or cannot be duplicated...

      SRread=.false.
      STread=.false.
      SGRead=.false.
      SMread=.false.
      SVRead=.false.
      DIread=.false.
      VBread=.false.

C OK, now interpret the parameters...

      do parcnt=1,stat,1

      if(params(parcnt)(1:13).eq.
     :  'POLAR_RADIUS:') then
        if(SRread) goto 6500
        read(params(parcnt)(14:),'(F20.0)',err=8500) RPole
        RPole=RPole*RSun
        SRread=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'POLAR_TEMPERATURE:') then
        if(STread) goto 6500
        read(params(parcnt)(19:),'(F20.0)',err=8500) TPole
        STread=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'POLAR_LOG_GRAVITY:') then
        if(SGread.or.SMread) goto 6500
        read(params(parcnt)(19:),'(F20.0)',err=8500) GPole
        GPole=10.D0**(GPole-2.D0)
        SGread=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'POLAR_MKS_GRAVITY:') then
        if(SGread.or.SMread) goto 6500
        read(params(parcnt)(19:),'(F20.0)',err=8500) GPole
        SGread=.true.
      elseif(params(parcnt)(1:13).eq.
     :  'STELLAR_MASS:') then
        if(SMread.or.SGread) goto 6500
        read(params(parcnt)(14:),'(F20.0)',err=8500) MStar
        MStar=MStar*MSun
        SMread=.true.
      elseif(params(parcnt)(1:20).eq.
     :  'EQUATORIAL_VELOCITY:') then
        if(SVread) goto 6500
        read(params(parcnt)(21:),'(F20.0)',err=8500) VEq
        VEq=VEq*1000.D0
        SVread=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'POLAR_INCLINATION:') then
        if(DIread) goto 6500
        read(params(parcnt)(19:),'(F20.0)',err=8500) DIncl
        DIncl=D360*DIncl/(360.D0)
        DIread=.true.
      elseif(params(parcnt)(1:12).eq.
     :  'ZEIPEL_BETA:') then
        if(VBread) goto 6500
        read(params(parcnt)(13:),'(F20.0)',err=8500) Beta
        VBread=.true.
      else
        goto 7500
      endif

      enddo

C Check that all the necessary parameters have been read.

      if(.not.SRread) then
        write(chandl,
     :  '(''*** Polar_Radius was not defined in #Stellar command'')')
        goto 9000
      elseif(.not.STread) then
        write(chandl,
     :  '(''*** Polar_Temperature was not defined
     : in #Stellar command'')')
        goto 9000
      elseif(.not.SVread) then
        write(chandl,
     :  '(''*** Equatorial_Velocity was not defined
     :  in #Stellar command'')')
        goto 9000
      endif

C Now we do a bit of validation on the figures. We do not validate Veq to
C allow for negative Omega's

      if(Rpole.le.0.D0) then
        write(chandl,
     :  '(''*** Polar_Radius was 0 or less in #Stellar command'')')
        goto 9000
      elseif(TPole.le.0.D0) then
        write(chandl,
     :  '(''*** Polar_Temperature was 0 or less in #Stellar command'')')
        goto 9000
      endif

C When we do the check for SMread and SGread, we must just check that neither
C of them is defined...

      if(SGread) then
        MStar=GPole*RPole**2/BigG
      elseif(SMread) then
        GPole=BigG*MStar/RPole**2
      else
        write(chandl,
     :  '(''*** Polar_Gravity/Stellar_Mass was not defined '',
     :  ''in #Stellar Command'')')
        goto 9000
      endif

C Validate that MStar is gt 0 - this will check GPole also

      if(MStar.le.0.D0) then
        write(chandl,
     :  '(''*** Stellar_Mass/Polar_Gravity is 0 or less '',
     :  ''in #Stellar command'')')
        goto 9000
      endif

C OK, now check that the rotation is sub-critical - if it is, set up Omega from
C Veq and Req, otherwise bum out...

      VCrit=sqrt(BigG*MStar/(1.5D0*Rpole))

      if(Veq.ge.VCrit) then
        write(chandl,
     :  '('' *** Equatorial_Velocity in #Stellar command leads to '',
     :  ''super-critical rotation (VCrit='',F10.3,'')'')') VCrit
        goto 9000
      endif

      REq=BigG*MStar/(BigG*MStar/RPole-0.5D0*VEq**2)

      Omega=VEq/REq

C If Beta was not specified, it defaults to 0.25:

      if(.not.VBread) Beta=0.25D0

C Ok, go on to the next bit...


C**************************************************************************

C This part is for unrecognised commands.....

      else
        write(6,
     : '(''*** An unrecognised command was found at line '',I2)') nline
        goto 9000
      endif

C**************************************************************************

C Now we deal with the cases where stat <= 0

C Checks to see if stat was zero - if it was, jump out...

      elseif(stat.eq.0) then
        goto 5000

C Otherwise, we have had an error - give a report...

      elseif(stat.eq.-1) then
        write(chandl,
     :  '(''*** Unknown command found at line '',I2)') nline
        stop
      elseif(stat.eq.-2) then
        write(chandl,
     :  '(''*** Command too long at line '',I2)') nline
        stop
      elseif(stat.eq.-3) then
        write(chandl,
     :  '(''*** A command was not followed by { on line '',I2)') nline
        stop
      elseif(stat.eq.-4) then
        write(chandl,
     :  '(''*** A spurious { was found at line '',I2)') nline
        stop
      elseif(stat.eq.-5) then
        write(chandl,
     :  '(''*** There were too many parameters (runaway list?) at
     : line '',I2)') nline
        stop
      elseif(stat.eq.-6) then
        write(chandl,
     :  '(''*** Parameter too long at line '',I2)') nline
        stop
      elseif(stat.eq.-7) then
        write(chandl,
     :  '(''*** End-of-file found when reading parameters at '',
     :  ''line '',I2)') nline
        stop
      elseif(stat.eq.-8) then
        write(chandl,
     :  '(''*** There was a general error reading line '',I2)') nline
      else
        write(chandl,
     :  '(''*** There was an unspecified error reading line '',
     :  I2)') nline
        stop
      endif

C Loop back around to read the next line...
 
      goto 1000

C This is the jump-in point for a `legal' end-of-file

 5000 continue

C First check if any modes have been defined - we have to do this here
C because the MODE command may be used more than once

      if(NModes.eq.0) then
        write(chandl,
     : '(''*** There were no #Modes commands found'')')
        goto 9000
      endif

C Now check that the other commands have been used.

      if(.not.timcom) then
        write(chandl,
     :  '(''*** There was no #Timings command found'')')
        goto 9000
      elseif(.not.fiecom) then
        write(chandl,
     :  '(''*** There was no #Fields command found'')')
        goto 9000
      elseif(.not.stecom) then
        write(chandl,
     :  '(''*** There was no #Stellar command found'')')
        goto 9000
      endif


C Now loop over the mode definitions to see of they have any pending variables
C which need setting up...

      do mcount=1,NModes,1

C If ppend is true, the observers period for this mode was given instead of the corotating
C period, so the angular frequency must be adjusted to get CFmode to a
C corotating rather than observers value. 

      if(ppend(mcount)) then 
        CFmode(mcount)=CFmode(mcount)+Mmode(mcount)*Omega
      endif

C Set up the value of K

      Kmode(mcount)=Gpole/(Rpole*CFmode(mcount)**2)

C If the Apend flag is true, we set up the roAp adjustment amplitude for the mode using
C the polar axis RAxOff - otherwise, we set the amplitude adjustment to unity

      if(Apend(mcount)) then 
        NAmode(mcount)=rapmatx(RAxOff,Lmode(mcount),roApM(mcount),
     :  Mmode(mcount)) 
      else
        NAmode(mcount)=1.D0
      endif

C If Lee & Saio modes are used, we check that none of the modes have m=0

      if(LSDEff.and.Mmode(mcount).eq.0) then
        write(chandl,
     :  '(''*** Lee&Saio cannot be used on modes with M_Value=0'')')
        goto 9000
      endif

C Now we see if the user has specified physical amplitudes. If they have, we
C loop over the modes to turn the mathematical amplitudes into real amplitudes.

      if(PhyAmp) then

         if(numode(mcount).eq.0.) then
            nutemp = 2.D0*Omega/CFmode(mcount)
         else
            nutemp = numode(mcount)
         endif
         if(HAmode(mcount).eq.0.) then
            HAtemp = Kmode(mcount)
         else
            HAtemp = HAmode(mcount)
         endif

         VAmode(mcount)=VAmode(mcount)/
     :        bgetmax(nutemp,HAtemp,
     :        Mmode(mcount),Jmode(mcount),parity(mcount))

      endif

C Loop back around...

      enddo

C Set up the timings array based on user information. If a timings file is
C specified, read it in; otherwise, use Tstart and Tend, calculating them
C from one of the mode periods if needs be

      if(RTread) then
        open(unit=thandl,file=TmFile,status='old',err=8600)

        NField=0

        write(chandl,'(''  Reading timings from file '',A)') TmFile

 5100   continue
        read(thandl,*,end=5200,err=8600) Time
        NField=NField+1
        if(NField.gt.maxfld) goto 8700
        Times(NField)=Time*3600.D0
        goto 5100

 5200   continue

        close(thandl)

      else

C Set up Tstart and Tend if timings are to come from a mode (these
C are in seconds)

        if(MPpend) then
          if(modper.le.NModes.and.modper.gt.0) then
            TStart=0.D0
            TEnd=dabs(D360/((CFmode(modper)-Mmode(modper)*Omega)*
     :                3600.D0))
          else
            write(chandl,'(''*** Faliure trying to obtain timings '',
     :    ''from undefined mode'')')
            goto 9000
          endif
        endif

C Do a consistency check if IncEnd is .true.

        if(IncEnd.and.NField.lt.2) then
          write(chandl,
     :    '(''*** Include_Endpoints requires at least 2 fields'')')
          goto 9000
        endif

C Check that the NField value is OK

        if(.not.NFread) then
          write(chandl,
     :    '(''*** Number of fields has not been defined'')')
          goto 9000
        endif

        if(NField.le.0) then
          write(chandl,
     :    '(''*** Number of fields is less than 1'')')
          goto 9000
        elseif(NField.gt.maxfld) then
          goto 8700
        endif


C Based on these values, set up the timings array

        do fcount=1,NField
          if(IncEnd) then
            Times(fcount)=(TStart+(fcount-1.0D0)/(NField-1.D0)*
     :                    (TEnd-TStart))*3600.D0
          else
            Times(fcount)=(TStart+(fcount-0.5D0)/dble(NField)*
     :                    (TEnd-TStart))*3600.D0
          endif
        enddo

      endif

C Set up ok for a normal exit status...

      ok=.true.

      goto 9000

C This is the jump in point for a duplicated parameter...

 6500 continue

      write(chandl,
     :  '(''*** A duplicated parameter was found in the #'',A,
     :''command at line '',I2,'' : '',A)') 
     : commnd(1:index(commnd,' ')),nline,params(parcnt)

        goto 9000

C This is the jump-in point for an unknown parameter error

 7500   write(chandl,
     :  '(''*** An undefined parameter was found in the #'',A,
     :''command at line '',I2,'' : '',A)') 
     :  commnd(1:index(commnd,' ')),nline,params(parcnt)
        goto 9000

C This is the jump-in point for float read errors

 8500 continue

      write(chandl,
     :  '(''*** There was an error reading a number at line'',
     :  I3)') nline
      goto 9000

C This is the jump in point for an error reading a timings file

 8600 continue

      write(chandl,
     : '(''*** An error was encountered whilst reading the '',
     : ''timings file '',A)') TmFile
      goto 9000
       

C This is the jump-in point for too many fields

 8700 continue

       write(chandl,
     : '(''*** Too many fields were defined (maximum '',
     : I2,'') - Please request a recompile'')') maxfld
       goto 9000

C This is the jump-in point for exiting

 9000 continue

      return

      end

      subroutine klojob(ok)

C*************************************************
C
C This routine is very similar to blojob
C in that it reads lines from a
C file (or stdin) with file handle fhandl, and
C parses them, setting up all of the parameters
C which kylie needs to perform her calculations.
C Any error conditions
C result in a report written out to file handle
C chandl; when clojob returns, ok is set up to
C be .true. for an ok exit, or .false. for an
C error condition. Most of the variables used
C are declared in common block include files -
C these files contain all the documentation regarding
C what the variables are. Note that in this
C modification the wavelength grid is set up, rather
C than being read in from an external file
C
C Started :25/9/95
C Modified:11/10/95
C
C***************************************************** 

C Turn of implicit typing

      implicit none

C Define the hard-wired parameters

      include "kylie.compar_define.inc"

C Load in the File control common block

      include "kylie.filcon_common.inc"

C Load in the File names common block

      include "kylie.filnam_common.inc"

C Load in the wavelength grid & field info common block

      include "kylie.wavfld_common.inc"

C Declare the passed variables

      logical ok		! The exit status of the subroutine

C Declare the in-program variables

      character*120 commnd       ! Character string to hold commands read
      character*120 params(9)    ! Array to hold the parameters read
      
      integer stat              ! Returned status value from lparse
      integer nline             ! Current line being parsed in input file
      integer parcnt		! A counter used to read the parameters in
      integer wcount		! Counter used to set up a waveband definition

      real WStart     		! The start wavelength for a waveband definition
      real WEnd			! The end wavelength for a waveband definition
      real WRes			! The wavelength resolution for a waveband definition
      real WavLen 		! The wavelength for a wavepoint definition

C Declare the in-program control flags

      logical fiecom		! Flag to check that an fields command is found
      logical outcom		! Flag to check that only one output command is used

      logical Dmread		! Flag set when the dump filestub is read
      logical NFread		! Flag set when the number of fields is read
      logical SWread		! Flag set when a start wavelength is read
      logical FWread		! Flag set when a finish wavelength is read
      logical WRread		! Flag set when the wavelength resolution is read
      logical WLread		! Flag set when a wavelength point is read
      logical LBread		! Flag set when the limb-darkening beta is read

C Include the constants file and the stellar file

      include 'constants.inc'
      include 'angles.inc'

C Initialise any variables which need to be done before reading
C the parameters

      ok=.false.

      fiecom=.false.
      TimFil='**none**'
      WrtTim=.false.

      NWDef=0

      LimbB=-1.

      write(chandl,'('' Parsing file....'')')

C Now we read lines from the file, using lparse, which parses the
C the input file and gets command/parameter pairs. parser returns
C a value in stat which remarks on the success of the read.

C First initialise nline to be 0...

      nline=0

 1000 continue

C Set up stat to be equal to the dimension of params

      stat=9 

      call parser(fhandl,chandl,commnd,params,stat,nline)

C Now, if stat is greater than zero, interpret the command
C in a huge if_then loop. Note that indenting is not used here.

      if(stat.gt.0) then

C************************************************************************

C OK, deal with the fields command

      if(commnd.eq.'FIELDS') then

C Check that this is the only fields command - if not, bum out

      if(fiecom) then
        write(chandl,
     :  '(''*** A spurious #Fields command was found at line '',
     :  I2)') nline
        goto 9000
      else
        fiecom=.true.
      endif

C Initialise the parameters

      Dmread=.false.
      NFread=.false.
      LBread=.false.

C Interpret all of the parameters

      do parcnt=1,stat,1

      if(params(parcnt)(1:14).eq.
     :  'DUMP_FILESTUB:') then
        if(Dmread) goto 6500
        read(params(parcnt)(15:),'(A)') DmStub
        Dmread=.true.
      elseif(params(parcnt)(1:17).eq.
     :  'NUMBER_OF_FIELDS:') then
        if(NFread) goto 6500
        read(params(parcnt)(18:),'(I5)',err=8500) NField
        NFread=.true.
      elseif(params(parcnt)(1:16).eq.
     :  'LIMB_U_OVERRIDE:') then
        if(LBread) goto 6500
        read(params(parcnt)(17:),'(F20.0)',err=8500) LimbB
        LBread=.true.
      else
        goto 7500
      endif
     
      enddo

C Check we have all of the parameters...

      if(.not.Dmread) then
        write(chandl,
     :   '(''*** Dump_Filestub was not defined'',
     :   '' in #Fields command'')')
        goto 9000
      elseif(.not.NFread) then
        write(chandl,
     :   '(''*** Number_of_Fields was not defined'',
     :   '' in #Fields command'')')
        goto 9000
      endif

C Check the number of fields is ok...

      if(NField.le.0) then
        write(chandl,
     :  '(''*** Number_of_Fields was less than 1 '',
     :  ''in #Fields command'')')
        goto 9000
      elseif(NField.gt.maxfld) then
        write(chandl,
     :  '(''*** Number_of_Fields was too large (maximum '',
     :  I2,'') in #Fields command'')')
        goto 9000
      endif   

C**************************************************************************

C Now deal with a waveband command. We do not need to check that this is the
C only waveband command, since we are allowed more than one...

      elseif(commnd.eq.'WAVEBAND') then

C Initialise the flags for the variables which must be read

      SWread=.false.
      FWread=.false.
      WRread=.false.

C Interpret all of the parameters

      do parcnt=1,stat,1

      if(params(parcnt)(1:17).eq.
     :  'START_WAVELENGTH:') then
        if(SWread) goto 6500
        read(params(parcnt)(18:),'(F20.0)',err=8500) WStart
        SWread=.true.
      elseif(params(parcnt)(1:18).eq.
     :  'FINISH_WAVELENGTH:') then
        if(FWread) goto 6500
        read(params(parcnt)(19:),'(F20.0)',err=8500) WEnd
        FWread=.true.
      elseif(params(parcnt)(1:22).eq.
     :  'WAVELENGTH_RESOLUTION:') then
        if(WRread) goto 6500
        read(params(parcnt)(23:),'(F20.0)',err=8500) WRes
        WRread=.true.
      else
        goto 7500
      endif

      enddo

C Check we have all of the parameters...

      if(.not.SWread) then
        write(chandl,
     :   '(''*** Start_Wavelength was not defined'',
     :   '' in #Waveband command'')')
        goto 9000
      elseif(.not.FWread) then
        write(chandl,
     :   '(''*** Finish_Wavelength was not defined'',
     :   '' in #Waveband command'')')
        goto 9000
      elseif(.not.WRread) then
        write(chandl,
     :   '(''*** Wavelength_Resolution was not defined'',
     :   '' in #Waveband command'')')
        goto 9000
      endif

C Check that WRes is not zero

      if(WRes.eq.0.) then
        write(chandl,
     :   '(''*** Wavelength_Resolution was 0 in #Waveband '',
     :   ''command'')')
        goto 9000
      endif

C OK, now update the wavelength grid accordingly. First check we have enough
C space in the wavelength grid to put the new band in...

      if(NWDef+int((WEnd-WStart)/WRes)+2.gt.NWGrid) then
        write(chandl,
     :   '('' *** There is not enough space in the wavelength'',
     :   '' grid for the #Waveband command on line '',I3,
     :   ''('',I5,'' points) - please request a recompile'')')
     :   nline,NWGrid
         goto 9000
      endif

C If there is enough space, update the grid accordingly

      do wcount=0,int((WEnd-WStart)/WRes)+1
        NWDef=NWDef+1
        WGrid(NWDef)=WStart+wcount*WRes
      enddo

C**************************************************************************

C Now deal with a wavepoint command. We do not need to check that this is the
C only wavepoint command, since we are allowed more than one...

      elseif(commnd.eq.'WAVEPOINT') then

C Initialise the flags for the variables which must be read

      WLread=.false.

C Interpret all of the parameters

      do parcnt=1,stat,1

      if(params(parcnt)(1:11).eq.
     :  'WAVELENGTH:') then
        if(WLread) goto 6500
        read(params(parcnt)(12:),'(F20.0)',err=8500) WavLen
        WLread=.true.
      else
        goto 7500
      endif

      enddo

C Check we have all of the parameters...

      if(.not.WLread) then
        write(chandl,
     :   '(''*** Wavelength was not defined'',
     :   '' in #Wavepoint command'')')
        goto 9000
      endif

C OK, now update the wavelength grid accordingly. First check we have enough
C space in the wavelength grid to put the new band in...

      if(NWDef+1.gt.NWGrid) then
        write(chandl,
     :   '('' *** There is not enough space in the wavelength'',
     :   '' grid for the #Wavepoint command on line '',I3,
     :   ''('',I5,'' points) - please request a recompile'')')
     :   nline,NWGrid
         goto 9000
      endif

C If there is enough space, update the grid accordingly

      NWDef=NWDef+1
      WGrid(NWDef)=WavLen

C**************************************************************************

C Do the (optional) output command

      elseif(commnd.eq.'OUTPUT') then

C Check that this is the only fields command - if not, bum out

      if(outcom) then
        write(chandl,
     :  '(''*** A spurious #Output command was found at line '',
     :  I2)') nline
        goto 9000
      else
        outcom=.true.
      endif

C Interpret all of the parameters

      do parcnt=1,stat,1

      if(params(parcnt)(1:17).eq.
     :  'TIMINGS_FILENAME:') then
        if(WrtTim) goto 6500
        read(params(parcnt)(18:),'(A)') TimFil
        WrtTim=.true.
      else
        goto 7500
      endif

      enddo


C**************************************************************************

C This part is for unrecognised commands.....

      else
        print *,commnd
        write(6,
     : '(''*** An unrecognised command was found at line '',I2)') nline
        goto 9000
      endif

C**************************************************************************

C Now we deal with the cases where stat <= 0

C Checks to see if stat was zero - if it was, jump out...

      elseif(stat.eq.0) then
        goto 5000

C Otherwise, we have had an error - give a report...

      elseif(stat.eq.-1) then
        write(chandl,
     :  '(''*** Unknown command found at line '',I2)') nline
        stop
      elseif(stat.eq.-2) then
        write(chandl,
     :  '(''*** Command too long at line '',I2)') nline
        stop
      elseif(stat.eq.-3) then
        write(chandl,
     :  '(''*** A command was not followed by { on line '',I2)') nline
        stop
      elseif(stat.eq.-4) then
        write(chandl,
     :  '(''*** A spurious { was found at line '',I2)') nline
        stop
      elseif(stat.eq.-5) then
        write(chandl,
     :  '(''*** There were too many parameters (runaway list?) at
     : line '',I2)') nline
        stop
      elseif(stat.eq.-6) then
        write(chandl,
     :  '(''*** Parameter too long at line '',I2)') nline
        stop
      elseif(stat.eq.-7) then
        write(chandl,
     :  '(''*** End-of-file found when reading parameters at '',
     :  ''line '',I2)') nline
        stop
      elseif(stat.eq.-8) then
        write(chandl,
     :  '(''*** There was a general error reading line '',I2)') nline
      else
        write(chandl,
     :  '(''*** There was an unspecified error reading line '',
     :  I2)') nline
        stop
      endif

C Loop back around to read the next line...
 
      goto 1000

C This is the jump-in point for a `legal' end-of-file

 5000 continue

C Check that we found all the necessary commands

      if(.not.fiecom) then
        write(chandl,
     :  '('' *** There was no #Fields command found'')')
        goto 9000
      endif 

C Check that at least one wavelength point was defined

      if(NWDef.le.0) then
        write(chandl,
     :  '('' *** There were no wavelength points defined'')')
        goto 9000
      endif

C Set up ok for a normal exit status...

      ok=.true.

      goto 9000

C This is the jump in point for a duplicated parameter...

 6500 continue

      write(chandl,
     :  '(''*** An duplicated parameter was found in the #'',A,
     :''command at line '',I2,'' : '',A)') 
     : commnd(1:index(commnd,' ')),nline,params(parcnt)

        goto 9000

C This is the jump-in point for an unknown parameter error

 7500   write(chandl,
     :  '(''*** An undefined parameter was found in the #'',A,
     :''command at line '',I2,'' : '',A)') 
     :  commnd(1:index(commnd,' ')),nline,params(parcnt)
        goto 9000

C This is the jump-in point for float read errors

 8500 continue

      write(chandl,
     :  '(''*** There was an error reading a number at line'',
     :  I3)') nline

C This is the jump-in point for exiting

 9000 continue

      return

      end

      function lsdFl(m,l,nu)

C******************************************************************
C
C This function returns the value of Lee & Saio's F(l) function,
C as defined in their MNRAS (1987) 221, 513-526 paper. This
C function can have singular values, but these are not checked for;
C the calling procedure must check for such singularities before
C F(l) is called. Note that F(l) is defined in terms of two parameters
C nu and m.
C
C (c) Richard Townsend 1995
C
C******************************************************************

      implicit none	! Turn off implicit typing

C Declare the passed variables

      double precision lsdFl	! The value of F(l)
      integer m	     		! The m-value of the F(l) function to be used
      double precision nu       ! The nu (rotation parameter) for F(l) function
      integer l	     		! The value of l to calculate F(l) at.

C Declare the in-program variables

      double precision lsdJml	! Lee & Saio's Jml(l,m) function - see MNRAS 221

C Set up the value of Fl...

      if(l.le.iabs(m)) then

        lsdFl=l*(l+2) * (lsdJml(m,l+1))**2 / ((l+1)**2 * 
     :   (1-m*nu/((l+1)*(l+2)) ) )

      else
        if(l.eq.1.and.m.eq.0) then
          lsdFl=
     :   l*(l+2) * (lsdJml(m,l+1))**2 / ((l+1)**2 * 
     :   (1-m*nu/((l+1)*(l+2)) ) )
        else
          lsdFl=(l**2-1) * (lsdJml(m,l))**2 / 
     :   (l**2 * (1 - m*nu/( (l-1)*l) ) ) +
     :   l*(l+2) * (lsdJml(m,l+1))**2 / ((l+1)**2 * 
     :   (1-m*nu/((l+1)*(l+2)) ) )
        endif
      endif

C Return...

      return

      end

      subroutine parser(fhandl,chandl,commnd,params,stat,nline)

C *************************************************
C
C This subroutine reads and parses commands and
C associated parameters from an already-opened file
C with file handle fhandle. Upon each call, a command
C will be read into character variable commnd, and
C a set of parameters (up to a maximum number of stat
C on entry) will be read into the array params. The 
C command/parameters must be of the following syntax:
C
C #<command> { [<param 1>] [<param2>] ... }
C
C The spaces around the braces {} *are* significant.
C This syntax may be split over any number of lines at
C the spaces; more than one space is the same as a single
C space. At any point in the file, if a % character
C is found, the rest of the current line is discarded,
C and a new line is read - this is for comments. Likewise,
C if a ! character is found, the rest of the line is
C written to file handle chandl as an run-time visual
C comment. Once the command and all of the parameters
C are read, parser exits with a positive value in stat
C equal to the number of parameters read. If the end
C of file (EOF) is encountered, a value of 0 is returned
C in stat. If an error occurs, a negative value is 
C returned in stat, the significance of which is as follows:
C
C   -1  --- The command does not begin with a #
C   -2  --- The command is too long to fit in commnd
C   -3  --- The command is not followed by a {
C   -4  --- A spurious { appears in the parameter list
C   -5  --- There are too many (>stat on entry) parameters in the list
C   -6  --- A parameter is too long to fit in params
C   -7  --- EOF was reached whilst reading a parameter list
C   -8  --- There was a FORTRAN error reading from the input file
C
C Started:12/9/95
C Version:0.00
C
C *************************************************

C Turn off implicit typing...

      implicit none

C Declare the passed variables...

      integer fhandl           ! The file handle of the input file
      integer chandl           ! The file handle of the output comment file
      character*(*) commnd     ! The returned command string
      character*(*) params(*)  ! The returned parameters array
      integer stat             ! On entry: the maximum number of parameters allowed
                               ! On exit: the error status value (see above)
      integer nline             ! The number of the line being parsed

C Declare the in-program variables...

      character*(120) cline    ! A character string to hold the current line awaiting parsing
      character*(120) cword    ! A character string holding the word being parsed
      integer sindex           ! The index into cline of the first space
      integer pindex           ! The index into cline of the first % (Percent) char
      integer bindex           ! The index into cline of the first ! (Bang) char
      integer parcnt           ! A counter used whilst reading the parameters

C Set up cline for the first time the subroutine is called.

      data cline /' '/

C Make sure that cline is not corrupted between calls

      save cline

C OK, if cline containts only spaces, read another line from the input file.
C Note that even though we compare cline with ' ', ' ' is expanded out to
C LEN(cline) spaces, and so will properly see if cline is only spaces.
C Also, do any relevent space stripping with sstrip

 100  if(cline.eq.' ') then
        read(fhandl,'(A)',end=9000,err=9200) cline
        call sstrip(cline)
        nline=nline+1
        goto 100
      endif

C Now, see if there are any % chars in the current line - if so, dump the line
C from the % onwards, and loop back to 100 to see if we need a new line...

      pindex=index(cline,'%')

      if(pindex.ne.0) then
        if(pindex.eq.1) then
          cline=' '
          goto 100
        else
          cline=cline(:pindex-1)
        endif
      endif

C Now see if there are any ! chars in the current line - if so, write the line
C from the ! onwards to chandl, chop it off cline, and loop back to 100 to
C see if we need a new line

      bindex=index(cline,'!')

      if(bindex.ne.0) then
        write(chandl,'(A)') cline(bindex:)
        if(bindex.eq.1) then
          cline=' '
          goto 100
        else
          cline=cline(:bindex-1)
        endif
      endif

C OK, now we have done the preprocessing, we can get on with reading in the command.
C First find the index of the first space in cline. If this index is 0, cline
C can contain no spaces and must be all characters. Once we have got the word,
C modifiy cline accordingly, and set up sindex to be the length of the command.
C The modified cline must be sstrip'ed again, because modifying it may reveal leading
C spaces...

      sindex=index(cline,' ')

      if(sindex.eq.0) then
        cword=cline
        cline=' '
        sindex=len(cword)
      else
        cword=cline(1:sindex-1)
        cline=cline(sindex:)
        call sstrip(cline)
        sindex=sindex-1
      endif

C Convert cword to uppercase

      call dtoupp(cword)

C Check that the command begins with a # - if it does not, set up stat to return
C an error.

      if(cword(1:1).eq.'#') then
        cword=cword(2:)
      else
        stat=-1
        return
      endif

C OK, check that the length of cword does not exceed the size of commnd - if it
C does, return an error value in stat, otherwise, put cword into commnd

      if(sindex.gt.len(commnd)) then
        stat=-2
        return
      else
        commnd=cword
      endif

C Great, now we can read the parameters in. We read all of the parameters first using an
C if_then loop. First we reset cword, and then loop around until cword is '}'.
C Also, set parcnt, the parameter counter, to 0

      parcnt=0

      cword=' '

 200  if(cword.ne.'}') then

C Do the usual reading loop...

 300    if(cline.eq.' ') then
          read(fhandl,'(A)',end=9100,err=9200) cline
          call sstrip(cline)
          nline=nline+1
          goto 300
        endif

        pindex=index(cline,'%')


        if(pindex.ne.0) then
          if(pindex.eq.1) then
            cline=' '
            goto 300
          else
            cline=cline(:pindex-1)
          endif
        endif

        bindex=index(cline,'!')

        if(bindex.ne.0) then
          write(chandl,'(A)') cline(bindex:)
          if(bindex.eq.1) then
            cline=' '
            goto 300
          else
            cline=cline(:bindex-1)
          endif
        endif

        sindex=index(cline,' ')

        if(sindex.eq.0) then
          cword=cline
          cline=' '
          sindex=len(cword)
        else
          cword=cline(1:sindex-1)
          cline=cline(sindex:)
          call sstrip(cline)
          sindex=sindex-1
        endif

C We do a little fiddle here - if there is a colon in the word,
C we only dtoupp it up to the colon...

        if(index(cword,':').gt.1) then
          call dtoupp(cword(1:index(cword,':')-1))
        else
          call dtoupp(cword)
        endif

C OK, now we have the appropiate word and have modified cline, we can look at
C the parameter found. If this is the first parameter to be read (checked using
C parcnt), then it *must* be a {. Likewise, if this is *not* the first parameter
C read, then it nust *not* be a {. If the parameter is a }, we ignore it - it
C will be caught at the top of the loop

        if(parcnt.eq.0) then

C Here we check that the first char is a {

          if(cword.ne.'{') then
            stat=-3
            return
          else
            parcnt=1
          endif

C Here we check that { appears nowhere else

        elseif(cword.eq.'{') then
          stat=-4
          return

C Here we quickly do a length check on param, and store it. Also, we check if we are
C about to read too many parameters (the max number of parameters readable is in stat)

        elseif(cword.ne.'}') then

          if(parcnt.gt.stat) then
            stat=-5
            return
          elseif(sindex.gt.len(params(1))) then
            stat=-6
            return
          else
            params(parcnt)=cword
            parcnt=parcnt+1
          endif

C Here we do nothing if cword is }, since it will be picked up at the top of the loop

        else

C Finish the test...

        endif

C Loop back to get the next parameter

        goto 200

      endif    

C OK, now that we have read all of the parameters, we may set up stat with an OK
C return value, and leave the subroutine...

      stat=parcnt-1

      return


C This is the jump in point if an EOF is found when trying to read a command -
C this is 'non-fatal'

 9000 stat=0
      return

C This is the jump-in point if an EOF is found in the middle of reading parameters -
C this is 'fatal'

 9100 stat=-7
      return

C This is the jump-in point if an error is encountered in reading from the file

 9200 stat=-8
      return

C Finish...
 
      end

      function parfac(a,b)

C*********************************************************************
C
C This function takes two parameters a and b and 
C returns the value of the product (a+b)(a+b-1)(a+b-2)...(a-b+2)(a-b+1)
C The program does not check for b<=a; if b>a, the returned value is
C only for b=a.
C
C (c) Richard Townsend 1995
C
C**********************************************************************

      implicit none		! Turn off strong typing

C Declare the passed variables

      integer a			! The value of a
      integer b			! The value of b
      double precision parfac 	! The returned value of parfac

C Declare the in-program variables...

      integer i	 		! A loop variable

C Now initialise parfac

      parfac=1.D0

C Now just loop over i, updating parfac...

      do i=a-b+1,a+b,1
        parfac=parfac*i
      enddo

C Return...

      return

      end       

      program kylie

C***********************************************
C
C This program (so-named coz it's short and sweet)
C is designed to take raw output files from the
C program bruce, containing velocity, temperature,
C gravity, cosMu and projected area values for elements
C across the surface of a star, and use Keith Smith's
C tgprof3 routine to calculate spectra for the all
C the elements summed. The parameters for kylie are
C read in from a file pointed to by the environment
C parameter KYLIE_PARAMS; this file specifies the
C wavelength grid now
C
C Started   :25/9/95
C Modified  :11/10/95
C            4/9/96 - If the user specifies the
C            LIMB_BETA_OVERRIDE parameter in the #FIELDS
C            command, the limb-darkening is done artificially
C            using the supplied limb-darkening beta
C
C Modified  :19/7/97 - Modified to take command files from
C            standard input; DEC Fortran specific bits removed
C
C            8/1/99 - Made the output reporting more sensible,
C                     and renamed errcnt to nOut
C
C            3/2/99 - Put in a check to abort if temperatures
C                     or gravities drop below zero
C
C***************************************************

C Turn off implicit typing...

      implicit none

C Define the hard-wired parameters

      include "kylie.compar_define.inc"

C *** Start of Include block load ***

C Load in the File control common block

      include "kylie.filcon_common.inc"

C Load in the File names common block

      include "kylie.filnam_common.inc"

C Load in the wavelength/field common block

      include "kylie.wavfld_common.inc"

C LOad in the angles and constants include file

      include "angles.inc"

      include "constants.inc"

C *** End of Include Block Load ***

C Delclare the in-program variables

      character*80 string               ! A string variable to hold filenames, titles etc...
      character*80 title		! The title of the spectra written out
      character*24 getlog	        ! The login name of the user
      character*24 fdate	        ! The date at which the routine is run
      integer getcwd		        ! The get cwd function
      integer ierrno		        ! The error returned by getcwd
      integer ferr		        ! The error number for a file operation
      integer wcount		        ! Counter to loop over the wavelength grid points
      integer fcount			! Counter to loop through the fields to be processed
      integer gcount			! Counter to loop through the visible grid points of each field
      integer GrdVis			! The number of visible grid points for a given field
      integer nOut                      ! number of points outside tgkiel grids
      integer nIn                       ! number of points inside tgkiel grids
      logical ok		        ! A status value for some of the routines

      real FTime			! The times of the input dump files
      real FGrid(NWGrid)	        ! The absoulte flux grid
      real WRest			! The rest wavelength of an observed wavelength
      real dummy		        ! A dummy (scratch) variable

      real VProj		        ! The projected velocity
      real AProj			! The projected area
      real Grav				! The gravity
      real Temp				! The temperature
      real CosMu			! Cos(mu)
      real tgprof3			! Keith's tgkiel

C Declare the external, DEF Fortran-specific routines

      external getenv			! The external routine to read an environment variable
      external getlog			! The external function to read the login name
      external getcwd			! The external function to read the current dir
      external fdate

C Print out the introductory banner

      write(chandl,'('' Kylie Version '',F4.2,'' ('',A,'')'')')
     :                                             Version, Date
      write(chandl,'('' -------------------------------------------'',
     :''---------------'')')

C Call klojob to parse the standard input command file (which has file handle fhandl)
      
      call klojob(ok)

C Check that all was OK; otherise jump to the end of the program

      if(.not.ok) goto 9000

C Print out the number of wavelength points

      write(chandl,'(I5,'' Wavelength Grid points found'')') NWDef

C Initialise tgprof3
C MODIFY:
C **************************************************************
C *** REPLACE THIS WITH YOUR SPECTRAL-SYNTHESIS INIT ROUTINE ***
C **************************************************************
      
      dummy=tgprof3(0.,0.,0.,0.,ok)

C Check it loaded OK

      if(.not.ok) then
        write(ehandl,'('' *** There was an error attempting'',
     :  '' to initialise the model atmospheres'')')
        goto 9000
      endif

C Print out a separator line

      write(chandl,'(A)') ' '
      write(chandl,'('' -------------------------------------------'',
     :''-------------------------'')')
      write(chandl,'(1X,''Filename            '',1X,''Grid Size'',1X,
     :  ''   TgK In'',1X,''  TgK Out'',1X,''  TgK Tot'',1X,
     :  ''  % Out'')')
      write(chandl,'('' -------------------------------------------'',
     :''-------------------------'')')

C Loop over the number of fields defined (hope they are all there!)

      do fcount=1,NField,1

C Zero the data in the flux grid...

      do wcount=1,NWDef,1
        FGrid(wcount)=0.0
      enddo

C Get the name of the field into string

      write(string,'(A,I3.3)') 
     :  DmStub(1:index(DmStub,' ')-1),fcount

C Open the current dump file

      open(unit=dhandl,status='old',file=string,form='UNFORMATTED')

C Grab the number of visible grid points from the input file and the time

      read(dhandl) GrdVis,FTime

C Zero the TGkiel counters

      nOut=0
      nIn=0

C Read in the stellar parameters GrdVis times...

      do gcount=1,GrdVis,1

        read(dhandl) Temp,VProj,AProj,Grav,CosMu

C Check that the values are reasonable

        if(Grav.lt.0.) then
          write(chandl,'(''*** A negative-gravity point was '',
     :  ''found in the file'',A)') string(1:index(string,' '))
          goto 9000
        endif

        if(Temp.lt.0.) then
          write(chandl,'(''*** A negative-temperature point was '',
     :  ''found in the file'',A)') string(1:index(string,' '))
          goto 9000
        endif

C Covert the gravity into dex

        Grav=log10(Grav)+2.0

C Update the flux grid for this grid point

        do wcount=1,NWDef,1

C Get the rest wavelength of the wavelength we are looking at. Note that
C the velocity convention is that a positive velocity is a velocity *towards*
C the observer.

          WRest=WGrid(wcount)/(1.0-VProj/CLight)

C Call TGProf3 to set up the flux at this wavelength; if an error
C is returned, increment the error counter

C MODIFY:
C ***********************************************************************
C *** REPLACE THIS WITH YOUR SECTRAL-SYNTHESIS ROUTINE. IN THIS CASE, ***
C *** TGPROF3(T,G,M,W,O) RETURNS THE INTENSITY AT TEMPERATURE T,      ***
C *** GRAVITY G, LIMB-PARAMTER M (SAME AS COS THETA), REST WAVELENGTH ***
C *** W, AND SETS OK TO .TRUE. TO SIGNIFY SUCCESS.                    ***
C ***********************************************************************

          ok=.true.
          if(LimbB.lt.0) then
            FGrid(wcount)=FGrid(wcount)+
     :      AProj*tgprof3(Temp,Grav,CosMu,WRest,ok)
            if(.not.ok) then
              nOut=nOut+1
            else
              nIn=nIn+1
            endif
          else
            FGrid(wcount)=FGrid(wcount)+
     :      AProj*tgprof3(Temp,Grav,1.,WRest,ok)*
     :      ((1.-LimbB)+LimbB*CosMu)
            if(.not.ok) then
              nOut=nOut+1
            else
              nIn=nIn+1
            endif
          endif

C Loop back around to do the next wavelength point...

        enddo

C Get the next grid element from the raw file by looping back around...

      enddo

C Close the file...

      close(dhandl,iostat=ferr,err=8000)

C Write out the flux array to an .sdf file

      title=string(1:index(string,' ')-1)//'.sdf'

C MODIFY:
C *******************************************************
C *** REPLACE THIS WITH YOUR SPECTRUM-WRITING ROUTINE ***
C *******************************************************

      call wrsdf1(title(1:index(title,' ')-1),
     :            title(1:index(title,' ')-1),
     :            'Wavelength',
     :            'Flux',
     :            'Angstrom',
     :            'cgs',
     :            NWGrid,
     :            NWDef,
     :            WGrid,
     :            FGrid,
     :            ok)

C Print out some summary information

      write(chandl,'(1X,A20,1X,I9,1X,I9,1X,I9,1X,I9,5X,I3)') title,
     :  GrdVis,nIn,nOut,nOut+nIn,int(nOut/real(nOut+nIn)*100)

C Now loop back to get the name of the next dump file and open it up

      enddo

C Jump to the end of the program for a normal exit...

      goto 9000

C Error jump-in for failure on a dump file

 8000 continue

      write(chandl,'(''*** An error was encountered whilst'',
     :'' trying to acess the file '',A)') string
      goto 9000

C End pof program jump-in point

 9000 continue

      end

      subroutine lsdtqli(d,e,n,np,z)

C*******************************************************
C
C This is a double-precision version of the Numerical Recipies
C eigenvalue and eigenvector routine. This can be found on page
C 473 of the Second Edition. This version has the eigenvector
C matrix z passed with anything in it - this matrix does not
C have to contain the unit matrix.
C
C Updated:27/3/95 
C 
C (c) Numerical Recipies
C
C********************************************************
  
      implicit none
      integer n,np
      double precision d(np),e(np),z(np,np)
      integer i,iter,k,l,m
      double precision b,c,dd,f,g,p,r,s,lsdpythag

C This bit I have added to set up a unit matrix...

      do l=1,np
        do k=1,np
          if(k.eq.l) then
            z(k,l)=1.
          else
            z(k,l)=0.
          endif
        enddo
      enddo

      do i=2,n
        e(i-1)=e(i)
      enddo
      e(n)=0.D0
      do l=1,n
        iter=0
 1      do m=l,n-1
          dd=abs(d(m))+abs(d(m+1))
          if (abs(e(m))+dd.eq.dd) goto 2
        enddo
        m=n
 2      if(m.ne.l) then
          if(iter.eq.30)pause 'too many iterations in dctqli'
          iter=iter+1
          g=(d(l+1)-d(l))/(2.D0*e(l))
          r=lsdpythag(g,1.D0)
          g=d(m)-d(l)+e(l)/(g+dsign(r,g))
          s=1.D0
          c=1.D0
          p=0.D0
          do i=m-1,l,-1
            f=s*e(i)
            b=c*e(i)
            r=lsdpythag(f,g)
            e(i+1)=r
            if(r.eq.0.D0) then
              d(i+1)=d(i+1)-p
              e(m)=0.D0
              goto 1
            endif
            s=f/r
            c=g/r
            g=d(i+1)-p
            r=(d(i)-g)*s+2.D0*c*b
            p=s*r
            d(i+1)=g+p
            g=c*r-b
            do k=1,n
              f=z(k,i+1)
              z(k,i+1)=s*z(k,i)+c*f
              z(k,i)=c*z(k,i)-s*f
            enddo
          enddo
          d(l)=d(l)-p
          e(l)=g
          e(m)=0.D0
          goto 1
        endif
      enddo
      return
      end
      
